clear all
close all
%-------------------------------------------------------------------------%
% Option du programme
%-------------------------------------------------------------------------%
adapt_mesh = 0;  % 1 pour calculer le maillage mis a jour dans le cas d une serie d images, 0 sinon
new_m_iter = 0;  % 1 pour utiliser ce maillage mis a jour a chaque nouvelle image ref (il faut adapt_mesh = 1)
FlagVisu = 0;


%-------------------------------------------------------------------------%
% Paramètres
%-------------------------------------------------------------------------%
icase = 1;
Param.InterpMethod = '*cubic';    % choose '*cubic' or '*linear'
Param.Itermin = 3;
Param.Itermax = 25;
Param.IterDamage = 0;
Param.Lregul = 5;
Param.Lreguledge = Param.Lregul/2;
Param.Young = 1;
Param.nu = 0.01;
Param.CvCriter = 1.e-4;

% Chemins
% FileMask = '';
% RefMask = zeros(1,6);
PathName = '/usrtmp/mathieu/tests_iris3/test_close2/Cam1/';
FileName1 = 'Camera_No.1';
FileName3 = '.tif';
formatnum = '%06g';
NameMesh = 'Mesh';
NamePoly = 'Polygon';

% Images deformees
switch icase
    case 1
        inum0 = 0;
        inum1 = 2;
        inum2 = 50;
    case 2
        inum0 = 3;
        inum1 = 4;
        inum2 = 50;
end

% Série de paires
for ii = inum1:inum2
    FileName21 = num2str(ii-2,formatnum);
    FileName22 = num2str(ii-1,formatnum);
    FileName23 = num2str(ii,formatnum);
    FileNameRef = [PathName,FileName1,FileName22,FileName3];
    FileNameDef = [PathName,FileName1,FileName23,FileName3];
    
    %---------------------------------------------------------------------%
    % Premier calcul avec regularisation mecanique
    %---------------------------------------------------------------------%    
    if (exist([PathName,FileName1,FileName22,'-',FileName1,FileName23,'-Mesh.mat'],'file') == 0)
        % On initialise le calcul a 0
        FileIniU = '';
        load('./TMP/LastJob.mat','Job')
    else
        % On initialise avec le resultat precedent
        FileIniU = [PathName,FileName1,FileName22,'-',FileName1,FileName23,'-Mesh.mat'];
        load(FileIniU,'Job')
    end
    
    if ((ii == inum1) || (new_m_iter == 1))
        FileMesh = [NameMesh,num2str(ii-1,formatnum),'.mat'];
        FilePoly = [NamePoly,num2str(ii-1,formatnum),'.mat'];
        Job.Mesh = ['./TMP/',FileMesh];
        Job.Poly = ['./TMP/',FilePoly];
    else
        Job_temp = load('./TMP/LastJob.mat','Job');
        Job.Mesh = Job_temp.Job.Mesh;
        Job.Poly = Job_temp.Job.Poly;
        clear Job_temp
    end
    
    Job.Ref = FileNameRef;
    Job.Def = FileNameDef;
    Job.IniU = FileIniU;
    
    test_cv = 0;
    adpat_1fois = 0;
    while (test_cv == 0)
        fprintf('\n-----------------------------------------------------------');
        fprintf('\nRegularisation Mecanique (L = %d et %d dans les coins)',Param.Lregul,Param.Lreguledge);
        fprintf('\nImage Ref : %s',FileName22);
        fprintf('\nImage Def : %s',FileName23);
        fprintf('\nMaillage : %s',Job.Mesh);
        fprintf('\nPolygon : %s',Job.Poly);
        fprintf('\n-----------------------------------------------------------\n');
        
        TestMain4(Job,Param,FlagVisu)
        
        % Test de convergence
        Param_temp = load([PathName,FileName1,FileName22,'-',FileName1,FileName23,'-Image-',num2str(Param.Lregul),'.mat'],'Param');
        if ((Param_temp.Param.Iterfin == Param.Itermax) && (new_m_iter ~= 1))
            fprintf('\nCritère de convergence non atteint !\n');
            if ((ii == inum1) || (adpat_1fois == 1))
                fprintf('Le maillage est pourtant adapté à l image de reference\n');
                fprintf('--> ajuster le nombre d iterations max ou le critere de convergence\n');
                test_cv = 1;
            else
                Job.Mesh = ['./TMP/',NameMesh,num2str(ii-1,formatnum),'.mat'];
                Job.Poly = ['./TMP/',NamePoly,num2str(ii-1,formatnum),'.mat'];
                adpat_1fois = 1;
            end
        else
            test_cv = 1;
        end
        clear Param_temp
    end
    clear test_cv adpat_1fois
    close all

    %---------------------------------------------------------------------%
    % Adaptation du maillage
    %---------------------------------------------------------------------%
    if (adapt_mesh == 1)
        % Modification du Maillage
        load([PathName,FileName1,FileName22,'-',FileName1,FileName23,'-Mesh-',num2str(Param.Lregul),'.mat'],'Mesh','U')
        Mesh.Znode = Mesh.Znode + U(1:2:end-1) + i*U(2:2:end);
        save(['./TMP/',NameMesh,num2str(ii,formatnum),'.mat'],'Mesh')
        
        % Modification du Polygon
        load(['./TMP/',FilePoly])
        xmin = min(real(Mesh.Znode));
        ymin = min(imag(Mesh.Znode));
        xmax = max(real(Mesh.Znode));
        ymax = max(imag(Mesh.Znode));
        XPoly = [xmin-1,xmax+1,xmax+1,xmin-1]';
        YPoly = [ymin-1,ymin-1,ymax+1,ymax+1]';
        Z = XPoly+1i*YPoly;
        FileName = FileNameDef;
        save(['./TMP/',NamePoly,num2str(ii,formatnum),'.mat'],'FileName','NPoly','ROI','RefPoly','Z','nZ')
        clear Mesh U FileName NPoly ROI RefPoly Z nZ XPoly YPoly xmax xmin ymax ymin
    end
end

for jj = inum1:inum2
    %---------------------------------------------------------------------%
    % Second calcul en relaxant la regularisation mecanique
    %---------------------------------------------------------------------%
    FileName21 = num2str(jj-2,formatnum);
    FileName22 = num2str(jj-1,formatnum);
    FileName23 = num2str(jj,formatnum);
    FileNameRef = [PathName,FileName1,FileName22,FileName3];
    FileNameDef = [PathName,FileName1,FileName23,FileName3];
    
    fprintf('\n-----------------------------------------------------------');
    fprintf('\nRegularisation Mecanique (L = %d et %d dans les coins)',Param.Lregul,Param.Lreguledge);
    fprintf('\nImage Ref : %s',FileName22);
    fprintf('\nImage Def : %s',FileName23);
    fprintf('\nMaillage : %s',FileMesh);
    fprintf('\nPolygon : %s',FilePoly);
    fprintf('\n-----------------------------------------------------------\n');
    
    % On initialise avec le resultat precedent
    FileIniU = [PathName,FileName1,FileName22,'-',FileName1,FileName23,'-Mesh.mat'];
    load(FileIniU,'Job')
    
    Param.Lregul = 1;
    Param.Lreguledge = Param.Lregul/2;    
    if (new_m_iter == 1)
        FileMesh = [NameMesh,num2str(jj-1,formatnum),'.mat'];
        FilePoly = [NamePoly,num2str(jj-1,formatnum),'.mat'];
        Job.Mesh = ['./TMP/',FileMesh];
        Job.Poly = ['./TMP/',FilePoly];
    end
    Job.Ref = FileNameRef;
    Job.Def = FileNameDef;
    Job.IniU = FileIniU;
    
    TestMain4(Job,Param,FlagVisu)
    
    if FlagVisu&(jj<inum2)
        % pause
        close all
    end
end
