function  [NewJob,Mask]=Choose_Mask2(WorkFile,FlagBatch,LastJob,NewJob,im,FlagVisu)

%% %%%%%%%%%%%%%%% SELECT MASK %%%%%%%%%%%%%%%%%%%%%%
if FlagBatch
    if FlagVisu
        HandleFigFull=ShowIm(im,'ROI','ROI',NewJob.ROI);
        ShowMask(HandleFigFull,NewJob.Mask);
    end
elseif NewJob.UseMask~=0
    if isnan(NewJob.UseMask)
        NewJob.Mask=LastJob.Mask;
    end
    HandleFigFull=ShowIm(im,'ROI','ROI',NewJob.ROI);
    if isempty(NewJob.Mask)
        FlagSatisfied=0;
    else
        load(NewJob.Mask,'FileName','Z','nZ','ROI');
        if strcmp(FileName,NewJob.Ref)==0
            FlagSatisfied=0;
        else
            ShowMask(HandleFigFull,NewJob.Mask);
            answer = inputdlg('1 = Yes; 0 = No','Is Mask satisfactory ?',1,{'1'});
            FlagSatisfied=str2num(answer{1});
            if ~FlagSatisfied
                close(HandleFigFull);
                HandleFigFull=ShowIm(im,'ROI','ROI',NewJob.ROI);
            end
        end
    end

    if ~FlagSatisfied
        answer=inputdlg('1 = Yes; 0 = No','Use Mask ?',1,{'0'});
        FlagMask=str2num(answer{1});
        if FlagMask==0
            NewJob.UseMask=0;
            NewJob.Mask='';
            NewJob.RefMask=zeros(1,6);
            FlagSatisfied=1;
        end
    end

    if ~FlagSatisfied
        answer=inputdlg('1 = Select; 0 = Define','Select Mask File or define it?',1,{'0'});
        if str2num(answer{1})
            FileList=FindMaskFile(NewJob);
            if size(FileList,1)==0
                FlagSatisfied=0;
            else
                [Selection,ok] = listdlg('PromptString','Select a file:',...
                    'SelectionMode','single',...
                    'ListString',FileList);
                if ok==0
                    FlagSatisfied=0;
                else
                    FlagSatisfied=1;
                    NewJob.UseMask=1;
                    NewJob.Mask=FileList{Selection};
                    load(NewJob.Mask,'RefMask');
                    NewJob.RefMask=RefMask;
                end
            end
        end
    end

    while ~FlagSatisfied
        NewJob.UseMask=1;
        figure(HandleFigFull);
        ROI=NewJob.ROI;
        Npoly=0;
        FlagSelectionMask=1;
        while FlagSelectionMask
            title('Choose Polygon (right click to end selection)')
            FlagSelectionPoly=1;
            x=[];y=[];
            while FlagSelectionPoly
                [ya,xa,za]=ginput(1);
                if za~=3;
                    y=[y,ya];x=[x,xa];
                    line(y(:),x(:),'Color','w')
                else
                    FlagSelectionPoly=0;
                end
            end
            Npoly=Npoly+1;
            nZ(Npoly)=length(x);
            Z(1:nZ(Npoly),Npoly)=x(:)-ROI(1)+1+i*y(:)-i*ROI(2)+i;
            fill(y,x,'gray');
            answer=inputdlg('1 = Yes; 0 = No','Add another exclusion polygon ?',1,{'0'});
            FlagSelectionMask=str2num(answer{1});
        end
        RefMask=fix(clock);
        NewJob.RefMask=RefMask;
        title('ROI and Mask')
        answer = inputdlg('1 = Yes; 0 = No','Is Mask satisfactory ?',1,{'1'});
        FlagSatisfied=str2num(answer{1});
        if ~FlagSatisfied
            close(HandleFigFull);
            HandleFigFull=ShowIm(im,'ROI','ROI',NewJob.ROI);
        end
        [FileNameSave,PathNameSave]=uiputfile('./TMP/Mask*.mat','Save Mask File', WorkFile.Mask);
        FileNameSave=fullfile(PathNameSave,FileNameSave);
        PathNameSave=strrep(PathNameSave,'\','/');
        FileNameSave=strrep(FileNameSave,'\','/');
        FileName=NewJob.Ref;
        NewJob.Mask=FileNameSave;
        save(NewJob.Mask,'FileName','RefMask','Z','nZ','ROI')
    end
else
    NewJob.UseMask=0;
    NewJob.Mask='';
    NewJob.RefMask=zeros(1,6);
end

load(WorkFile.LastJob,'LastParam');
Job=NewJob;
save(WorkFile.LastJob,'Job','LastParam');

%% %%%%%%%%%%%%%% Generate image from Mask %%%%%%%%%%%%%

Mask=logical(ones(size(im)));
if NewJob.UseMask
    load(NewJob.Mask)
    Npoly=size(Z,2);
    [Y,X]=meshgrid([1:size(im,2)],[1:size(im,1)]);
    yp=imag(Z(1:nZ(ii),ii));
    xp=real(Z(1:nZ(ii),ii));
    for ii=1:Npoly
        Out = 1-inpolygon(yp,xp,Y,X);
        Mask=Mask&logical(Out);
    end
end
RefMask=NewJob.RefMask;
save(WorkFile.ImMask,'Mask','RefMask')

% st='Choose_Mask'
% LastJob
% NewJob

