function  [NewJob,Mesh]=Choose_Mesh(WorkFile,FlagBatch,LastJob,NewJob,Boundary,im,FlagVisu)

%% %%%%%%%%%%%%%%% SELECT MESH %%%%%%%%%%%%%%%%%%%%%%
FlagRefreshed=0;

if FlagBatch
    load(NewJob.Mesh);%'Mesh'
    disp(sprintf('Mesh File = %s',NewJob.Mesh))
    disp(sprintf('Mesh characteristic length = %g',Mesh.CharLength))
    if FlagVisu
        HandleFigMesh = ShowMesh(Mesh,NewJob.ROI);
    end
    [nx,ny] = size(im);
    roi = [1,1,nx,ny];
    [T,W1,W2,W3] = Pixel2Tri(Mesh.TRI,Mesh.Znode,roi);
    RefMesh = Mesh.RefMesh;
    save(WorkFile.ImMesh,'RefMesh','T','W1','W2','W3')
    
else
    if isempty(NewJob.Mesh)
        NewJob.Mesh=LastJob.Mesh;
    end
    if isempty(NewJob.Mesh)
        FlagSatisfied=0;
    else
        load(NewJob.Mesh);%'Mesh'   
        if ~isequal(Mesh.RefPoly,NewJob.RefPoly)
            FlagSatisfied=0;
        else
            NewJob.RefMesh=Mesh.RefMesh;
            HandleFigMesh=ShowMesh(Mesh,NewJob.ROI);
            disp(sprintf('Mesh File = %s',NewJob.Mesh))
            disp(sprintf('Mesh characteristic length = %g',Mesh.CharLength))
            answer = inputdlg('1 = Yes; 0 = No','Is Mesh satisfactory ?',1,{'1'});
            FlagSatisfied=str2num(answer{1});
            if ~FlagSatisfied
                close(HandleFigMesh);
                NewJob.Mesh='';
                NewJob.RefMesh=zeros(1,6);
            end
        end
    end
    
    if ~FlagSatisfied
        answer=inputdlg('1 = Select; 0 = Define','Select Mesh File or define it?',1,{'0'});
        if str2num(answer{1})
            FileList=FindMeshFile(NewJob);
            if size(FileList,1)==0
                FlagSatisfied=0;
            else
                [Selection,ok] = listdlg('PromptString','Select a file:',...
                    'SelectionMode','single',...
                    'ListString',FileList);
                if ok==0
                    FlagSatisfied=0;
                else
                    FlagSatisfied=1;
                    NewJob.Mesh=FileList{Selection}
                    load(NewJob.Mesh);
                    NewJob.RefMesh=Mesh.RefMesh;
                    FlagRefreshed=0;
                end
            end
        end
    end

    while ~FlagSatisfied
        MeshCharLength=inputdlg('Mesh Characteristic Length (in pixels) ?');
        MeshCharLength=str2num(MeshCharLength{1});
        %%%%%%%%%%%%%  TO BE DONE : REGIONS %%%%%%%%%%%%%%%%%%%%%%%%
        Region(1).CharLength=MeshCharLength;
        %Mesh=SimpleMesh2(MeshCharLength,Boundary,0);
        Mesh=SimpleMesh_v2(Region,Boundary,0);
        disp(sprintf('Mesh characteristic length = %g',Mesh.CharLength))
        Mesh.RefMesh=fix(clock);
        Mesh.RefPoly=NewJob.RefPoly;
        triplot(Mesh.TRI,imag(Mesh.Znode)+NewJob.ROI(2)-1,real(Mesh.Znode)+NewJob.ROI(1)-1,'k');
        FlagRefreshed=1;
        HandleFigMesh=ShowMesh(Mesh,NewJob.ROI);
        answer = inputdlg('1 = Yes; 0 = No','Is Mesh satisfactory ?',1,{'1'});
        FlagSatisfied=str2num(answer{1});
        [FileNameSave,PathNameSave]=uiputfile('./TMP/Mesh*.mat','Save Mesh File', WorkFile.Mesh);
        FileNameSave=fullfile(PathNameSave,FileNameSave);
        PathNameSave=strrep(PathNameSave,'\','/');
        FileNameSave=strrep(FileNameSave,'\','/');
        NewJob.Mesh=FileNameSave;
        save(NewJob.Mesh,'Mesh')
        NewJob.RefMesh=Mesh.RefMesh;
        disp(['Mesh File = ',NewJob.Mesh])
    end 
end 

load(WorkFile.LastJob,'LastParam');
Job=NewJob;
save(WorkFile.LastJob,'Job','LastParam');


%%
if (size(dir(WorkFile.ImMesh),1)==0)
    FlagRefreshed=1;
else
    load(WorkFile.ImMesh)
    if ~isequal(Mesh.RefMesh,RefMesh)
        FlagRefreshed=1;
    end
end
if FlagRefreshed
    [nx,ny]=size(im);
    roi=[1,1,nx,ny];
    [T,W1,W2,W3]=Pixel2Tri(Mesh.TRI,Mesh.Znode,roi);
    RefMesh=Mesh.RefMesh;
    save(WorkFile.ImMesh,'RefMesh','T','W1','W2','W3')
end    


% st='Choose_Mesh'
% LastJob
% NewJob

