function  [NewJob,Boundary]=Choose_Poly(WorkFile,FlagBatch,LastJob,NewJob,im,FlagVisu)

%% %%%%%%%%%%%%%%% SELECT POLYGON %%%%%%%%%%%%%%%%%%%%%%
if FlagBatch
    if FlagVisu
        HandleFigFull=ShowIm(im,'ROI','ROI',NewJob.ROI);
        ShowPoly(HandleFigFull,NewJob.Poly);
    end
    FlagRefreshed=0;
else
    HandleFigFull=ShowIm(im,'ROI','ROI',NewJob.ROI);
    if isempty(NewJob.Poly)
        NewJob.Poly=LastJob.Poly;
    end
    if isempty(NewJob.Poly)
        FlagSatisfied=0;
        FlagRefreshed=1;
    else
        load(NewJob.Poly,'RefPoly','Z','nZ','NPoly');
        NewJob.RefPoly=RefPoly;
        ShowPoly(HandleFigFull,NewJob.Poly);
        answer = inputdlg('1 = Yes; 0 = No','Is Polygon satisfactory ?',1,{'1'});
        FlagSatisfied=str2num(answer{1});
        if FlagSatisfied
            FlagRefreshed=0;
        else
            close(HandleFigFull);
            HandleFigFull=ShowIm(im,'ROI','ROI',NewJob.ROI);
            FlagRefreshed=1;
        end
    end

    if ~FlagSatisfied
        answer=inputdlg('1 = Select; 0 = Define','Select Polygon File or define it?',1,{'0'});
        if str2num(answer{1})
            FileList=FindPolyFile(NewJob);
            if size(FileList,1)==0
                FlagSatisfied=0;
            else
                [Selection,ok] = listdlg('PromptString','Select a file:',...
                    'SelectionMode','single',...
                    'ListString',FileList);
                if ok==0
                    FlagSatisfied=0;
                else
                    FlagSatisfied=1;
                    NewJob.Poly=FileList{Selection};
                    load(NewJob.Poly);
                    NewJob.RefPoly=RefPoly;
                    FlagRefreshed=0;
                end
            end
        end
    end
    
    while ~FlagSatisfied
        answer=inputdlg('Number of polygons ? ','Define Polygon(s)',1,{'1'});
        NPoly=str2num(answer{1});
        NewJob.NPoly=NPoly;
        RefPoly=fix(clock);
        RefMesh=zeros(1,6);
        NewJob.RefMesh=RefMesh;
        NewJob.RefPoly=RefPoly;
        ROI=NewJob.ROI;
        figure(HandleFigFull);
        for ipoly=1:NPoly
            FlagSelection=1;
            if ipoly==1
                title(sprintf('Choose Outer Polygon %g (right click to end selection)',ipoly))
            else
                title(sprintf('Choose Polygon %g (right click to end selection)',ipoly))
            end
            x=[];y=[];
            while FlagSelection
                [ya,xa,za]=ginput(1);
                if za~=3;
                    y=[y,ya];x=[x,xa];
                    line(y(:),x(:),'Color','r')
                else
                    FlagSelection=0;
                end
            end
            npt=length(x);
            Z(1:npt,ipoly)=x(:)-ROI(1)+1+i*y(:)-i*ROI(2)+i;
            nZ(ipoly)=npt;
            line([y(:);y(1)],[x(:);x(1)],'Color','w','LineWidth',2);
        end
        title('ROI and Polygon')
        answer = inputdlg('1 = Yes; 0 = No','Is ROI satisfactory ?',1,{'1'});
        FlagSatisfied=str2num(answer{1});
        if ~FlagSatisfied
            close(HandleFigFull);
            HandleFigFull=ShowIm(im,'ROI','ROI',NewJob.ROI);
        end
    end
end

if FlagRefreshed
    ROI=NewJob.ROI;
    FileName=NewJob.Ref;
    [FileNameSave,PathNameSave]=uiputfile('./TMP/Polygon*.mat','Save Polygon File', WorkFile.Polygon);
    FileNameSave=fullfile(PathNameSave,FileNameSave);
    PathNameSave=strrep(PathNameSave,'\','/');
    FileNameSave=strrep(FileNameSave,'\','/');
    NewJob.Poly=FileNameSave;
    RefPoly=NewJob.RefPoly;
    save(NewJob.Poly,'FileName','RefPoly','Z','nZ','ROI','NPoly')
end

load(WorkFile.LastJob,'LastParam');
Job=NewJob;
save(WorkFile.LastJob,'Job','LastParam');

load(NewJob.Poly)
Boundary.NPoly=NPoly;
Boundary.Z=Z;
Boundary.NNode=nZ;
Boundary.Type{1}='Outer';
if NPoly>1 
       Boundary.Type{2:NPoly}='Inner';
end
Boundary.Close(1:NPoly)=1;
Boundary.RefPoly=RefPoly;

% st='Choose_Poly'
% LastJob
% NewJob
































%
