function  [LastJob,NewJob,im1]=Choose_Ref(WorkFile,FlagBatch,NewJob,Param,FlagVisu)

if size(dir(WorkFile.LastJob),1)
    load(WorkFile.LastJob,'Job','LastParam')
    LastJob=Job;
else
    LastJob.Path=NewJob.Path;
    LastJob.Ref=NewJob.Path;
    LastJob.Def='';
    LastJob.ROI='';
    LastJob.Mask='';
    LastJob.RefMask=zeros(1,6);
    LastJob.Poly='';
    LastJob.RefPoly=zeros(1,6);
    LastJob.Mesh='';
    LastJob.RefMesh=zeros(1,6);
    LastParam=Param;
end
    
if FlagBatch
    if isempty(NewJob.ROI);  NewJob.ROI=LastJob.ROI;         end
    if isempty(NewJob.Mesh); NewJob.Mesh=LastJob.Mesh;       end
    if NewJob.RefPoly==0;    NewJob.RefPoly=LastJob.RefPoly; end
    if NewJob.RefMesh==0;    NewJob.RefMesh=LastJob.RefMesh; end
    if ~strcmp(NewJob.Ref,LastJob.Ref)
        im=ReadIm(NewJob.Ref);
        PathName=NewJob.Path;
        FileName=NewJob.Ref;
        ROI=NewJob.ROI;
        im1=im(ROI(1):ROI(3),ROI(2):ROI(4));
        save(WorkFile.ImRef,'PathName','FileName','ROI','im1');
    end
else
    k=max(strfind(LastJob.Ref,'.'));
    if isempty(k)
        Filter='*.*';
    else
        Filter=['*',LastJob.Ref(k:end)];
    end
    [FileName,PathName]=uigetfile(Filter,'Select a reference image file',LastJob.Ref);
    FileName=fullfile(PathName,FileName);
    PathName=strrep(PathName,'\','/');
    FileName=strrep(FileName,'\','/');
    NewJob.Ref=FileName;
    NewJob.Path=PathName;
    if strcmp(NewJob.Ref,LastJob.Ref)==0
        NewJob.Def=NewJob.Path;
    else
        NewJob.Def=LastJob.Def;
    end
end
disp(sprintf('Reference image file = %s',NewJob.Ref));
im=ReadIm(NewJob.Ref);

%% %%%%%%%%%%%%%%%%% SELECT SUBIMAGE %%%%%%%%%%%%%%%%%%%%%%

if FlagBatch
    if FlagVisu
        HandleFigFull=ShowIm(im,'Ref Image');
        ShowROI(HandleFigFull,NewJob.ROI);
    end
    ROI=NewJob.ROI;
    im1=im(ROI(1):ROI(3),ROI(2):ROI(4));
else
    im=ReadIm(NewJob.Ref);
    HandleFigFull=ShowIm(im,'Ref Image');
    if isempty(LastJob.ROI)
        FlagSatisfied=0;
    else
        LastJob.ROI(1)=min(LastJob.ROI(1),size(im,1));
        LastJob.ROI(2)=min(LastJob.ROI(2),size(im,2));
        LastJob.ROI(3)=min(LastJob.ROI(3),size(im,1));
        LastJob.ROI(4)=min(LastJob.ROI(4),size(im,2));
        ShowROI(HandleFigFull,LastJob.ROI);
        ROI=LastJob.ROI;
        im1=im(ROI(1):ROI(3),ROI(2):ROI(4));
        answer = inputdlg('1 = Yes; 0 = No','Is ROI satisfactory ?',1,{'1'});
        FlagSatisfied=str2num(answer{1});
        if ~FlagSatisfied
            close(HandleFigFull);
            HandleFigFull=ShowIm(im,'Ref Image');
        end
    end
    while ~FlagSatisfied
        figure(HandleFigFull)
        [y,x]=ginput(2);
        x=round(x);y=round(y);
        x=max(x,1);y=max(y,1);
        x=min(x,size(im,1));y=min(y,size(im,2));
        ROI=[min(x),min(y),max(x),max(y)];
        ShowROI(HandleFigFull,ROI);
        im1=im(ROI(1):ROI(3),ROI(2):ROI(4));
        answer = inputdlg('1 = Yes; 0 = No','Is ROI satisfactory ?',1,{'1'});
        FlagSatisfied=str2num(answer{1});
        if ~FlagSatisfied
            close(HandleFigFull);
            HandleFigFull=ShowIm(im,'Ref Image');
        end
    end

    NewJob.ROI=ROI;
    PathName=NewJob.Path;
    FileName=NewJob.Ref;
    save(WorkFile.ImRef,'PathName','FileName','ROI','im1');
end

if FlagVisu
    HandleFigROI=ShowIm(im1,'ROI','ROI',NewJob.ROI);
end

Job=NewJob;
save(WorkFile.LastJob,'Job','LastParam');

% st='Choose_Ref'
% LastJob
% NewJob
