clear all
close all

b=20;% box size
th0=60; % threshold of gray levels

im=imread('C:/Im_data/Mesh/composite00.bmp');
im=double(im);
im=im(:,1:end-1);

fig1=figure;
imagesc(im)
colormap(gray)
axis image

[nx,ny]=size(im);
jm=cumsum((im<th0),1);
jm=cumsum(jm,2);
f(1:nx-b,1:ny-b)=jm(1:nx-b,1:ny-b)-jm(1+b:nx,1:ny-b)-jm(1:nx-b,1+b:ny)+jm(1+b:nx,1+b:ny);

th=b*b-1;
mask=zeros(size(im));
mask(1:nx-b,1:ny-b)=(f(1:nx-b,1:ny-b)>th);
mask(1:nx-b,1+b:ny)=mask(1:nx-b,1+b:ny)|(f(1:nx-b,1:ny-b)>th);
mask(1+b:nx,1:ny-b)=mask(1+b:nx,1:ny-b)|(f(1:nx-b,1:ny-b)>th);
mask(1+b:nx,1+b:ny)=mask(1+b:nx,1+b:ny)|(f(1:nx-b,1:ny-b)>th);

figure
imagesc(mask.*im)
colormap(hot)
axis image

figure(fig1)
hold on
[C,h]=contour(mask,0.5,'color','r');

domain=zeros(size(im));
ind1=find(mask(2:end,:)~=mask(1:end-1,:));
domain(rem(ind1-1,nx-1)+1+(floor((ind1-1)/(nx-1)))*nx)=1;
ind1=find(mask(:,2:end)~=mask(:,1:end-1));
domain(rem(ind1-1,nx)+1+(floor((ind1-1)/(nx)))*nx)=1;

for ii=1:10
    domain(1:nx-1,:)=domain(1:nx-1,:)|domain(2:nx,:);
    domain(2:nx,:)=domain(1:nx-1,:)|domain(2:nx,:);
    domain(:,1:ny-1)=domain(:,1:ny-1)|domain(:,2:ny);
    domain(:,2:ny)=domain(:,1:ny-1)|domain(:,2:ny);
end

figure
imagesc(domain)
pause
break

z=double(mask);
z0=z;
ell=100;
fig3=figure;
colormap(hot)
ntot=nx*ny;
f1=-sin(z*2*pi)/ell;
f2=del2(z);
z=z+.2*(f1+f2);

for ii=1:50
%     maska=(abs(z-.5)<.499);
%     f1(maska)=-sin(z(maska)*2*pi)/ell;    
    ind=find((abs(z-.5)<.49999));
    f1=-sin(z(ind)*2*pi)/ell;
    ind1=mod(ind,ntot)+1;
    ind2=mod(ind+ntot-2,ntot)+1;
    ind3=mod(ind+nx,ntot)+1;
    ind4=mod(ind+ntot-nx,ntot)+1;
    f2=(z(ind1)+z(ind2)+z(ind3)+z(ind4))*.25-z(ind);
    %f1=-sin(z*2*pi)/ell;
    %f2=del2(z);
    z(ind)=z(ind)+.2*(f1+f2);
    z=min(z,1);
    z=max(z,0);
    z(1,:)=z0(1,:);
    z(:,1)=z0(:,1);
    z(end,:)=z0(end,:);
    z(:,end)=z0(:,end);
    figure(fig3)
    imagesc(z)
    axis image
    title(num2str(ii))
    pause(.1)
end

figure

[C2,h]=contour(z,0.5,'color','r');



