function    [Mtot,Mregul]=Compute_StiffnessMatrices(WorkFile,NewJob,LastJob,Param,im,D)

%% Refresh Elastic Stiffness if needed
FlagReDo=1;
if size(dir(WorkFile.Elast),1)
    load(WorkFile.Elast,'RefMesh');
    if min(NewJob.RefMesh==RefMesh)*min(D==0)==1
%        FlagReDo=0;
    end
end
if FlagReDo
    disp('Redo Elast')
    TriDICElast2(WorkFile,NewJob,Param.nu,D);
end

%% Refresh DIC Stiffness if needed
FlagReDo=1;
if size(dir(WorkFile.Rigid),1)
    load(WorkFile.Rigid,'RefMesh','FileName');
    if min(NewJob.RefMesh==RefMesh)*(strcmp(NewJob.Ref,LastJob.Ref))
        FlagReDo=0;
    end
end
if FlagReDo
    disp('Redo Rigid')
    TriDICRigid2(WorkFile,NewJob);
end

%% Refresh Edge Stiffness if needed
FlagReDo=1;
if size(dir(WorkFile.Edge),1)
    load(WorkFile.Edge,'RefMesh');
    if (NewJob.RefMesh==RefMesh)
%        FlagReDo=0;
    end
end
if FlagReDo
    disp('Redo Edge')
    TriDICEdge3(WorkFile,NewJob);
end

%% Normalize 
load(WorkFile.Rigid,'M');
load(WorkFile.Elast,'K');
load(WorkFile.Edge,'Kedge');
load(NewJob.Mesh,'Mesh');
X=real(Mesh.Znode);
Ndof=2*Mesh.NNodeTot;
V=zeros(Ndof,1);
RefLength=100;
V(1:2:Ndof)=sin(X*2*pi/RefLength);
Edic=V'*M*V;
Eel=V'*K*V;
Eed=V'*Kedge*V;
scalel=(Param.Lregul/RefLength)^4;
scaled=(Param.Lreguledge/RefLength)^4;
% Ael=Edic/Eel*scalel; % erroneous old version
% Aed=Edic/Eed*scaled; % erroneous old version
Ael=(Edic/Eel)^2*scalel;
Aed=(Edic/Eed)^2*scaled;
save(WorkFile.RigidWeight,'Ael','Aed');
%
Mregul=Ael*K+Aed*Kedge;
Mtot=Mregul+M;