function [Z]=FindCrack(d,WorkFile,icrack,ROI,FlagRefresh,FlagPlot,FlagFinalPlot)

load(WorkFile.ResultFileI)

if FlagPlot
    HandleFigResid=ShowIm(abs(Resid).*Mask,'Residual','ROI',[coorx(1),coory(1),coorx(end),coory(end)],'Colormap','hot');
end

if FlagRefresh
    title('Click end points')
    [y,x]=ginput(2);
    z=x+i*y;
    title('Residual')
    n=round(abs(z(2)-z(1))/d);
    defaultans{1}=num2str(n);
    answer = inputdlg('Number of points?','Crack feature',1,defaultans);
    Npt=str2num(answer{1});
    save(WorkFile.CrackEndPoints,'z','Npt');
else
    load(WorkFile.CrackEndPoints)
end
if FlagPlot
    hold on
    line(imag(z),real(z),'Color','w')
end
x0=floor(min(real(z)));x1=ceil(max(real(z)));
y0=floor(min(imag(z)));y1=ceil(max(imag(z)));
x2=2*round((x1-x0)/2)+20;
y2=2*round((y1-y0)/2)+20;
Resid0=Resid;
Mask0=Mask;
Resid=Resid(x0-10+[1:x2]-ROI(1)+1,y0-10+[1:y2]-ROI(2)-1);
Mask=Mask(x0-10+[1:x2]-ROI(1)+1,y0-10+[1:y2]-ROI(2)-1);
z=z-(x0+i*y0)+10*(1+i);
z1=z(1);
z2=z(2);

if FlagPlot
    FigResid=figure;
    colormap(hot)
    imagesc(abs(Resid).*Mask)
    caxis(150*[0 1])
    %axis image
    xlabel('$y$','Interpreter','latex')
    ylabel('$x$','Interpreter','latex')
    title('Residual')
    hold on
    line(imag(z),real(z),'Color','w')
    drawnow
end

[Y,X]=meshgrid([1:size(Resid,2)],[1:size(Resid,1)]);
R2=min(X,size(Resid,1)+1-X).^2+min(Y,size(Resid,2)+1-Y).^2;
L=10;
Filt=exp(-R2/L^2);
fResid=fft2(abs(Resid.*Mask));
fFilt=fft2(Filt);
gResid=real(ifft2(fFilt.*fResid));
%
if FlagPlot
    FigFilt=figure;
    colormap(hot)
    imagesc(gResid.*Mask)
    caxis(1.e3*[0 1])
    xlabel('$y$','Interpreter','latex')
    ylabel('$x$','Interpreter','latex')
    hold on
    line(imag(z),real(z),'Color','w')
end

Z=[0:Npt+1]/(Npt+1)*(z2-z1)+z1;
n=i*(z2-z1);n=n/abs(n);
q=3;
qr=50.;
for iter=1:20
    for ii=2:Npt+1
        d1=floor(abs(Z(ii)-Z(ii-1)));
        zz1=Z(ii-1)+[0:d1]/d1*(Z(ii)-Z(ii-1));
        a1=interp2(Y,X,abs(Resid),imag(zz1),real(zz1));
        zz1a=zz1+q*[0:d1]/d1*n;
        a1a=interp2(Y,X,abs(Resid),imag(zz1a),real(zz1a));
        zz1b=zz1-q*[0:d1]/d1*n;
        a1b=interp2(Y,X,abs(Resid),imag(zz1b),real(zz1b));
        if ii<Npt+2
            d2=floor(abs(Z(ii+1)-Z(ii)));
            zz2=Z(ii)+[0:d2]/d2*(Z(ii+1)-Z(ii));
            a2=interp2(Y,X,abs(gResid),imag(zz2),real(zz2));
            zz2a=zz2+q*[d2:-1:0]/d2*n;
            a2a=interp2(Y,X,abs(gResid),imag(zz2a),real(zz2a));
            zz2b=zz2-q*[d2:-1:0]/d2*n;
            a2b=interp2(Y,X,abs(gResid),imag(zz2b),real(zz2b));
            Zmean=(Z(ii+1)+Z(ii-1))/2;
        else
            a2=0;
            a2a=0;
            a2b=0;
            Zmean=Z(ii);
        end
        V0=sum(a1)+sum(a2);
        V0=V0-qr*abs(zz1(end)-Zmean).^2;
        V0a=sum(a1a)+sum(a2a);
        V0a=V0a-qr*abs(zz1a(end)-Zmean).^2;
        V0b=sum(a1b)+sum(a2b);
        V0b=V0b-qr*abs(zz1b(end)-Zmean).^2;
        p=polyfit(q*[-1:1],[V0b,V0,V0a],2);
        if p(1)>0
            [m,jj]=max([V0b,V0,V0a]);
            if jj==1
                Z(ii)=Z(ii)-q*n;
            elseif jj==3
                Z(ii)=Z(ii)+q*n;
            end
        else
            ds=-p(2)/2/p(1);
            ds=min(ds,2*q);
            ds=max(ds,-2*q);
            Z(ii)=Z(ii)+ds*n;
        end
    end
    if FlagPlot
        line(imag(Z),real(Z),'Color','b')
        drawnow
    end
end
if FlagPlot
    line(imag(Z),real(Z),'Color','g')
end

if FlagPlot
    figure(FigResid);
end

L=5;
Filt=exp(-R2/L^2);
fResid=fft2(abs(Resid.*Mask));
fFilt=fft2(Filt);
gResid=real(ifft2(fFilt.*fResid));
q=3;
qr=50.;
for iter=1:20
    for ii=2:Npt+1
        d1=floor(abs(Z(ii)-Z(ii-1)));
        zz1=Z(ii-1)+[0:d1]/d1*(Z(ii)-Z(ii-1));
        a1=interp2(Y,X,abs(Resid),imag(zz1),real(zz1));
        zz1a=zz1+q*[0:d1]/d1*n;
        a1a=interp2(Y,X,abs(Resid),imag(zz1a),real(zz1a));
        zz1b=zz1-q*[0:d1]/d1*n;
        a1b=interp2(Y,X,abs(Resid),imag(zz1b),real(zz1b));
        if ii<Npt+2
            d2=floor(abs(Z(ii+1)-Z(ii)));
            zz2=Z(ii)+[0:d2]/d2*(Z(ii+1)-Z(ii));
            a2=interp2(Y,X,abs(gResid),imag(zz2),real(zz2));
            zz2a=zz2+q*[d2:-1:0]/d2*n;
            a2a=interp2(Y,X,abs(gResid),imag(zz2a),real(zz2a));
            zz2b=zz2-q*[d2:-1:0]/d2*n;
            a2b=interp2(Y,X,abs(gResid),imag(zz2b),real(zz2b));
            Zmean=(Z(ii+1)+Z(ii-1))/2;
        else
            a2=0;
            a2a=0;
            a2b=0;
            Zmean=Z(ii);
        end
        V0=sum(a1)+sum(a2);
        V0=V0-qr*abs(zz1(end)-Zmean).^2;
        V0a=sum(a1a)+sum(a2a);
        V0a=V0a-qr*abs(zz1a(end)-Zmean).^2;
        V0b=sum(a1b)+sum(a2b);
        V0b=V0b-qr*abs(zz1b(end)-Zmean).^2;
        p=polyfit(q*[-1:1],[V0b,V0,V0a],2);
        if p(1)>0
            [m,jj]=max([V0b,V0,V0a]);
            if jj==1
                Z(ii)=Z(ii)-q*n;
            elseif jj==3
                Z(ii)=Z(ii)+q*n;
            end
        else
            ds=-p(2)/2/p(1);
            ds=min(ds,2*q);
            ds=max(ds,-2*q);
            Z(ii)=Z(ii)+ds*n;
        end
    end
    if FlagPlot
        line(imag(Z),real(Z),'Color','b')
        drawnow
    end
end
if FlagPlot
    line(imag(Z),real(Z),'Color','g')
end


if FlagPlot
    figure(FigResid);
end

q=2;
qr=10.;
for iter=1:10
    for ii=2:Npt+1
        d1=floor(abs(Z(ii)-Z(ii-1)));
        zz1=Z(ii-1)+[0:d1]/d1*(Z(ii)-Z(ii-1));
        a1=interp2(Y,X,abs(Resid),imag(zz1),real(zz1));
        zz1a=zz1+q*[0:d1]/d1*n;
        a1a=interp2(Y,X,abs(Resid),imag(zz1a),real(zz1a));
        zz1b=zz1-q*[0:d1]/d1*n;
        a1b=interp2(Y,X,abs(Resid),imag(zz1b),real(zz1b));
        if ii<Npt+2
            d2=floor(abs(Z(ii+1)-Z(ii)));
            zz2=Z(ii)+[0:d2]/d2*(Z(ii+1)-Z(ii));
            a2=interp2(Y,X,abs(Resid),imag(zz2),real(zz2));
            zz2a=zz2+q*[d2:-1:0]/d2*n;
            a2a=interp2(Y,X,abs(Resid),imag(zz2a),real(zz2a));
            zz2b=zz2-q*[d2:-1:0]/d2*n;
            a2b=interp2(Y,X,abs(Resid),imag(zz2b),real(zz2b));
            Zmean=(Z(ii+1)+Z(ii-1))/2;
        else
            a2=0;
            a2a=0;
            a2b=0;
            Zmean=Z(ii);
        end
        V0=sum(a1)+sum(a2);
        V0=V0-qr*abs(zz1(end)-Zmean).^2;
        V0a=sum(a1a)+sum(a2a);
        V0a=V0a-qr*abs(zz1a(end)-Zmean).^2;
        V0b=sum(a1b)+sum(a2b);
        V0b=V0b-qr*abs(zz1b(end)-Zmean).^2;
        p=polyfit(q*[-1:1],[V0b,V0,V0a],2);
        if p(1)>0
            [m,jj]=max([V0b,V0,V0a]);
            if jj==1
                Z(ii)=Z(ii)-q*n;
            elseif jj==3
                Z(ii)=Z(ii)+q*n;
            end
        else
            ds=-p(2)/2/p(1);
            ds=min(ds,2*q);
            ds=max(ds,-2*q);
            Z(ii)=Z(ii)+ds*n;
        end
    end
    if FlagPlot
        line(imag(Z),real(Z),'Color','b')
        drawnow
    end
end
if FlagPlot
    line(imag(Z),real(Z),'Color','g')
end

Z=Z+(x0+i*y0)-10*(1+i);
if FlagFinalPlot
    figure
    colormap(hot)
    imagesc(coory,coorx,abs(Resid0).*Mask0)
    caxis(150*[0 1])
    xlabel('$y$','Interpreter','latex')
    ylabel('$x$','Interpreter','latex')
    line(imag(Z),real(Z),'Color','w');
    set(gca,'Position',[0.18 0.16 0.72 0.77]);
    axis image
end
if FlagPlot
    figure
    colormap(hot)
    imagesc(coory,coorx,abs(Resid0).*Mask0)
    caxis(150*[0 1])
    xlabel('$y$','Interpreter','latex')
    ylabel('$x$','Interpreter','latex')
    set(gca,'Position',[0.18 0.16 0.72 0.77]);
    axis image
end

Z=Z-(ROI(1)-1+i*(ROI(2)-1));

save(WorkFile.CrackPath{icrack},'Z','Npt');

