function [zcont1,zcont2,znorm]=Mask2Boundary(mask,step,FlagPlot)

% input:
% mask =image binaire
% step = sous-echantillonnage du contour (7  10 est raisonnable)
% FlagPlot = 1 si les figures sont tracees, 0 sinon
% Output:
% zcont1 = vecteur des points du contour (nombres complexes)
% zcont2 = vecteur des centres des segments du contour (nombres complexes)
% znorm = vecteur des normales extrieures (nombres complexes)

[nx,ny]=size(mask);

if FlagPlot
    figure
    imagesc(mask)
    colormap(hot)
    axis image
    xlabel('$x$')
    ylabel('$y$')
end

C=contourc(double(mask),[.5 .5]);
zcont1=C(1,2:end)+i*C(2,2:end);
zcont1=[zcont1(1:step:end-1),zcont1(1)];
zcont2=.5*(zcont1(2:end)+zcont1(1:end-1));
zcont2=[zcont2,zcont2(1)];
znorm =.5*(zcont1(2:end)-zcont1(1:end-1));
znorm=i*znorm./abs(znorm);
znorm=[znorm,znorm(1)];

if FlagPlot
    figure
    line(real(zcont1),imag(zcont1),'Color','k')
    axis image
    xlim(nx*[0 1])
    ylim(ny*[0 1])
    xlabel('$x$')
    ylabel('$y$')

    figure
    quiver(real(zcont2),imag(zcont2),real(znorm),imag(znorm),'Color','k')
    axis image
    xlim(nx*[0 1])
    ylim(ny*[0 1])
    xlabel('$x$')
    ylabel('$y$')
end
