%%% Program MoveCrackBoundary 
%%%

InterpMethod='*cubic';
load(WorkFile.ResultFileM,'Mesh','U');
load(WorkFile.ImRef,'im1');
load(WorkFile.ImDef,'imdef');
for ii=1:Mesh.NBoundary
    icrack2(ii)=strcmp('Crack2',Mesh.Type{ii});
end
ib=find(icrack2);
ia=Mesh.BParent(ib);

load(WorkFile.Rigid,'M');
load(WorkFile.Elast,'K');
load(WorkFile.Edge,'Kedge')

for ii=1:length(ib);

    inode1=Mesh.INodeEdge(ia(ii))-1+[1:Mesh.NNodeEdge(ia(ii))];
    inode2=[inode1(1),Mesh.INodeEdge(ib(ii))-1+[Mesh.NNodeEdge(ib(ii)):-1:1],inode1(end)];

    FMx=M(2*inode1-1,:)*U;
    FMy=M(2*inode1  ,:)*U;
    FKx=K(2*inode1-1,:)*U;
    FKy=K(2*inode1  ,:)*U;
    FKedgex=Kedge(2*inode1-1,:)*U;
    FKedgey=Kedge(2*inode1  ,:)*U;
    F2Mx=M(2*inode2-1,:)*U;
    F2My=M(2*inode2  ,:)*U;
    F2Kx=K(2*inode2-1,:)*U;
    F2Ky=K(2*inode2  ,:)*U;
    F2Kedgex=Kedge(2*inode2-1,:)*U;
    F2Kedgey=Kedge(2*inode2  ,:)*U;
    Z1=Mesh.Znode(inode1);
    Z2=Mesh.Znode(inode2);

%     figure
%     plot(real(Z1),-(U1-U2),'k-')
%     hold on
%     %plot(real(Z1),U2,'k:')
%     plot(real(Z1),V1-V2,'r-')
%     %plot(real(Z1),V2,'r:')
%     xlim([100 900])
%     xlabel('$y$','Interpreter','latex')
%     ylabel('$\Delta U$  (pix.)','Interpreter','latex')
%     legend('$-\Delta U_x$','$\Delta U_y$')

    % figure
    % plot(Z1,'k.-')
    % hold on
    % plot(Z2,'r.-')

    figure
    quiver(imag(Z1),real(Z1),FMy,FMx,'Color','r')
    hold on
    quiver(imag(Z1),real(Z1),F2My,F2Mx,'Color','k')
    axis ij
    axis image
    xlim([200 500])
    ylim([100 900])
    line(imag(Z1),real(Z1),'Color','k')
    xlabel('$y$','Interpreter','latex')
    ylabel('$x$','Interpreter','latex')
    title('Fdic')

    figure
    quiver(imag(Z1),real(Z1),FKy,FKx,'Color','r')
    hold on
    quiver(imag(Z1),real(Z1),F2Ky,F2Kx,'Color','k')
    axis ij
    axis image
    xlim([200 500])
    ylim([100 900])
    line(imag(Z1),real(Z1),'Color','k')
    xlabel('$y$','Interpreter','latex')
    ylabel('$x$','Interpreter','latex')
    title('Fmech')

    figure
    quiver(imag(Z1),real(Z1),FKedgey,FKedgex,'Color','r')
    hold on
    quiver(imag(Z1),real(Z1),F2Kedgey,F2Kedgex,'Color','k')
    axis ij
    axis image
    xlim([200 500])
    ylim([100 900])
    line(imag(Z1),real(Z1),'Color','k')
    xlabel('$y$','Interpreter','latex')
    ylabel('$x$','Interpreter','latex')
    title('Fedge')
end

ii=1;
in=12;
inode1=Mesh.INodeEdge(ia(ii))-1+in;
inode2=Mesh.INodeEdge(ib(ii))+1+Mesh.NNodeEdge(ib(ii))-in;
ind1=find(Mesh.TRI==inode1);
ind2=find(Mesh.TRI==inode2);
indel1=mod(ind1-1,Mesh.Nelem)+1;
indel2=mod(ind2-1,Mesh.Nelem)+1;

SubMesh.Close=1;
SubMesh.Type{1}='Outer';
SubMesh.RefPoly=Mesh.RefPoly;
im=3;
ip=1;
renum=zeros(Mesh.NNodeTot,1);
for ij=1:length(indel1)
    iq=indel1(ij);
    for ik=1:3
        if Mesh.TRI(iq,ik)==inode1
            renum(inode1)=1;
            SubMesh.Znode(1)=Mesh.Znode(inode1);
        elseif Mesh.TRI(iq,ik)==inode2
            renum(inode2)=2;
            SubMesh.Znode(2)=Mesh.Znode(inode2);
        elseif renum(Mesh.TRI(iq,ik))==0
            renum(Mesh.TRI(iq,ik))=im;
            SubMesh.Znode(im)=Mesh.Znode(Mesh.TRI(iq,ik));
            im=im+1;
        end
    end
    SubMesh.TRI(ij,1:3)=renum(Mesh.TRI(iq,:));
end
for ij=1:length(indel2)
    iq=indel2(ij);
    for ik=1:3
        if Mesh.TRI(iq,ik)==inode1
            renum(inode1)=1;
            SubMesh.Znode(1)=Mesh.Znode(inode1);
            Uini(1:2)=U(2*inode1+[-1:0]);
        elseif Mesh.TRI(iq,ik)==inode2
            renum(inode2)=2;
            SubMesh.Znode(2)=Mesh.Znode(inode2);
            Uini(3:4)=U(2*inode2+[-1:0]);
        elseif renum(Mesh.TRI(iq,ik))==0
            renum(Mesh.TRI(iq,ik))=im;
            SubMesh.Znode(im)=Mesh.Znode(Mesh.TRI(iq,ik));
            Uini(2*im+[-1:0])=U(2*Mesh.TRI(iq,ik)+[-1:0]);
            im=im+1;
        end
    end
    SubMesh.TRI(ij+length(indel1),1:3)=renum(Mesh.TRI(iq,:));
end
SubMesh.NNodeIn=2;
SubMesh.NNodeEdge=im-1-2;
SubMesh.INodeEdge=3;
SubMesh.NBoundary=1;
SubMesh.NNodeTot=im-1;
SubMesh.RefMesh=now;
SubMesh.CharLength=Mesh.CharLength;
SubMesh.Nelem=size(SubMesh.TRI,1);
SubMesh.BParent=0;

iCrack=find(strcmp(Mesh.Type,'Crack'));
iCrack0=SubMesh.NNodeTot;
iCrack1=0;
for ij=Mesh.INodeEdge(iCrack):Mesh.INodeEdge(iCrack)+Mesh.NNodeEdge(iCrack)
    if renum(ij)>0
        iCrack0=min(iCrack0,renum(ij));
        iCrack1=max(iCrack1,renum(ij));
    end
end
jCrack0=iCrack0;
jCrack1=iCrack1;
        

ROI(1)=floor(min(real(SubMesh.Znode(:))))-5;
ROI(2)=floor(min(imag(SubMesh.Znode(:))))-5;
ROI(3)=ceil(max(real(SubMesh.Znode(:))))+5;
ROI(4)=ceil(max(imag(SubMesh.Znode(:))))+5;

% figure;
% triplot(SubMesh.TRI,imag(SubMesh.Znode),real(SubMesh.Znode),'k')
% xlim([ROI(2) ROI(4)])
% ylim([ROI(1) ROI(3)])
% axis ij;axis image
% xlabel('$y$','Interpreter','latex')
% ylabel('$x$','Interpreter','latex')
% title('SubMesh')
% drawnow

im10=im1;
imdef0=imdef;
im1=im1(ROI(1):ROI(3),ROI(2):ROI(4));
imdef=imdef(ROI(1):ROI(3),ROI(2):ROI(4));
SubMesh.Znode=SubMesh.Znode-(ROI(1)-1)-i*(ROI(2)-1);
[nx,ny]=size(im1);
roi=[1,1,nx,ny];
[T,W1,W2,W3]=Pixel2Tri(SubMesh.TRI,SubMesh.Znode,roi);
indin=find(T>0);
[Yref,Xref]=meshgrid([1:ny],[1:nx]);
meanref=mean(im1(indin));
stdref=std(im1(indin));

figure
imagesc(imdef)
colormap(hot)
hold on
triplot(SubMesh.TRI,imag(SubMesh.Znode),real(SubMesh.Znode),'k')
axis image

%%%%%%%%%% Compute K
E=1;
nu=0.2;
mu=E/2/(1+nu);
lambda=(E/(1-2*nu)-2*mu)/3;
kappa=2*mu/3+lambda;
D=0;

j1=zeros(36*SubMesh.Nelem,1);
j2=zeros(36*SubMesh.Nelem,1);
kel=zeros(36*SubMesh.Nelem,1);
for ii=1:SubMesh.Nelem
    ia=SubMesh.TRI(ii,1);
    ib=SubMesh.TRI(ii,2);
    ic=SubMesh.TRI(ii,3);
    inddof=repmat([2*ia-1;2*ia;2*ib-1;2*ib;2*ic-1;2*ic],[1 6]);
    j1(36*(ii-1)+[1:36])=inddof(:);
    inddof=inddof';
    j2(36*(ii-1)+[1:36])=inddof(:);
    Z=[SubMesh.Znode(ia),SubMesh.Znode(ib),SubMesh.Znode(ic)];
    [K,M,P]=StiffElem(Z,mu,lambda,D);
    kel(36*(ii-1)+[1:36])=K(:);
end
clear K K1
Ndof=2*SubMesh.NNodeTot;
K1=sparse(j1,j2,kel,Ndof,Ndof);
NdofIn=2*SubMesh.NNodeIn;
K=K1(:,1:NdofIn)*K1(1:NdofIn,:); % Equilibrium gap !

%%%%%%%%%% Compute M
clear M
[Gy,Gx]=gradient(im1);
[nx,ny]=size(im1);
Nelem=SubMesh.Nelem;

Gx1=Gx.*W1;
Gx2=Gx.*W2;
Gx3=Gx.*W3;
clear Gx
Gy1=Gy.*W1;
Gy2=Gy.*W2;
Gy3=Gy.*W3;
clear Gy f

ind1=zeros(36*Nelem,1);
ind2=zeros(36*Nelem,1);
kel=zeros(36*Nelem,1);
ijj=0;
for ii=1:Nelem
    iinode=SubMesh.TRI(ii,:);
    xmin=floor(min(real(SubMesh.Znode(iinode))));
    xmax=floor(max(real(SubMesh.Znode(iinode))));
    ymin=ceil(min(imag(SubMesh.Znode(iinode))));
    ymax=ceil(max(imag(SubMesh.Znode(iinode))));
    x=[xmin:xmax];
    y=[ymin:ymax];
    [Y,X]=meshgrid(y,x);
    IN=inpolygon(Y,X,imag(SubMesh.Znode(iinode)),real(SubMesh.Znode(iinode)));
    ind=find(IN);
    ix=X(ind);
    iy=Y(ind);
    indim=ix+(iy-1)*nx;
    idof=[2*iinode(1)-1,2*iinode(1),2*iinode(2)-1,2*iinode(2),2*iinode(3)-1,2*iinode(3)];
    f(:,1)=Gx1(indim);
    f(:,2)=Gy1(indim);
    f(:,3)=Gx2(indim);
    f(:,4)=Gy2(indim);
    f(:,5)=Gx3(indim);
    f(:,6)=Gy3(indim);
    for ij=1:6
        ind1(ijj+1)=idof(ij);
        ind2(ijj+1)=idof(ij);
        kel(ijj+1)=sum(f(:,ij).^2);
        ijj=ijj+1;
        for ik=ij+1:6
            ind1(ijj+[1:2])=[idof(ij);idof(ik)];
            ind2(ijj+[1:2])=[idof(ik);idof(ij)];
            kel(ijj+[1:2])=sum(f(:,ij).*f(:,ik))*ones(2,1);
            ijj=ijj+2;
        end
    end
    clear f;
end   
Ndof=2*SubMesh.NNodeTot;
M=sparse(ind1,ind2,kel,Ndof,Ndof);

%%%%%%%%%%%%%%%%   Kedge
clear Kedge
ind1=[];
ind2=[];
kel=[];

m=3;
Z=[SubMesh.Znode(iCrack0);1;SubMesh.Znode(iCrack1)];
dZp=Z(2:m)-Z(1:m-1);
dZm(2:m)=dZp(1:m-1);
ij=2;
ik=1;
ikp=iCrack1;
ikm=iCrack0;
ind1=cat(1,ind1,2*[ik ;ik;ik ]-1);
ind2=cat(1,ind2,2*[ikp;ik;ikm]-1);
kel=[kel;-conj(dZp(2))./abs(dZp(2));...
    conj(dZp(2))./abs(dZp(2))+conj(dZm(2))./abs(dZm(2));...
    -conj(dZm(2))./abs(dZm(2))];
ind1=cat(1,ind1,2*[ik ;ik;ik ]);
ind2=cat(1,ind2,2*[ikp;ik;ikm]);
kel=[kel;-conj(dZp(2))./abs(dZp(2));...
    conj(dZp(2))./abs(dZp(2))+conj(dZm(2))./abs(dZm(2));...
    -conj(dZm(2))./abs(dZm(2))];

Z=[SubMesh.Znode(jCrack0);1;SubMesh.Znode(jCrack1)];
dZp=Z(2:m)-Z(1:m-1);
dZm(2:m)=dZp(1:m-1);
ij=2;
ik=2;
ikp=iCrack1;
ikm=iCrack0;
ind1=cat(1,ind1,2*[ik ;ik;ik ]-1);
ind2=cat(1,ind2,2*[ikp;ik;ikm]-1);
kel=[kel;-conj(dZp(2))./abs(dZp(2));...
    conj(dZp(2))./abs(dZp(2))+conj(dZm(2))./abs(dZm(2));...
    -conj(dZm(2))./abs(dZm(2))];
ind1=cat(1,ind1,2*[ik ;ik;ik ]);
ind2=cat(1,ind2,2*[ikp;ik;ikm]);
kel=[kel;-conj(dZp(2))./abs(dZp(2));...
    conj(dZp(2))./abs(dZp(2))+conj(dZm(2))./abs(dZm(2));...
    -conj(dZm(2))./abs(dZm(2))];

m=2*SubMesh.NNodeTot;
K2=sparse(ind1,ind2,kel,m,m);
Kedge=real(K2'*K2);

%%%%%%%%%%%%%%%% Load Weights
load(WorkFile.RigidWeight,'Ael','Aed');
Mregul=M+Ael*K+Aed*Kedge;


FigUx=figure('Position',[16   606   672   504]);
FigUy=figure('Position',[582   606   672   504]);
FigDiff=figure('Position',[1168   606   672   504]);
coorx=[ROI(1):ROI(3)];
coory=[ROI(2):ROI(4)];
U=Uini';
dyn=max(im1(:));
itermax=50;
itermin=15;
resnorm0=1;
%%%%%%%%%%%%%%%%% Computation loop %%%%%%%%%%%%%%%%%%%%%%

for iter=1:itermax

    Uxpix=InterpMeshNode(ROI,T,W1,W2,W3,SubMesh.TRI,U(1:2:end-1));
    Uypix=InterpMeshNode(ROI,T,W1,W2,W3,SubMesh.TRI,U(2:2:end));
    ind=find(isnan(Uxpix));
    % Uxpix(ind)=0;
    % Uypix(ind)=0;

    figure(FigUx);
    colormap(hot)
    imagesc(coory,coorx,Uxpix);
    axis image
    title('$U_x$','Interpreter','latex')
    xlabel('$y$','Interpreter','latex')
    ylabel('$x$','Interpreter','latex')
    set(gca,'Position',[.14 .14 .7 .73]);
    drawnow
    figure(FigUy);
    colormap(hot)
    imagesc(coory,coorx,Uypix);
    axis image
    title('$U_y$','Interpreter','latex')
    xlabel('$y$','Interpreter','latex')
    ylabel('$x$','Interpreter','latex')
    set(gca,'Position',[.14 .14 .7 .73]);
    drawnow


    %%%%%%%%%%%%%%%%% Correct image %%%%%%%%%%%%%%%%%%%%%%
    % nxdef=size(imdef,1);
    % nydef=size(imdef,2);
    Xcor=Xref+Uxpix;
    Ycor=Yref+Uypix;
    jm1=zeros(size(im1));
    jm1(indin)=interp2(Yref,Xref,imdef,Ycor(indin),Xcor(indin),InterpMethod);
    jm1=jm1/std(jm1(indin))*stdref;
    jm1=jm1-mean(jm1(indin))+meanref;

    %%%%%%%%%%%%%%%%% Get residuals %%%%%%%%%%%%%%%%%%%%%%
    Resid=im1-jm1;
    resnorm0=resnorm;
    resnorm=std(Resid(indin(:)))/dyn;
    disp(sprintf('     Iter        = %g',iter));
    disp(sprintf('        Residual = %g',resnorm));
    disp(sprintf('        dUx      = %g',mean(dU(1:2:end))));
    disp(sprintf('        dUy      = %g',mean(dU(2:2:end))));
    disp(sprintf('          Ux     = %g',mean(U(1:2:end))));
    disp(sprintf('          Uy     = %g',mean(U(2:2:end))));

    figure(FigDiff);
    colormap(hot)
    imagesc(coory,coorx,(im1-jm1));
    set(gca,'Position',[.14 .14 .7 .73]);
    caxis(800*[-1 1]);
    axis image
    title('Residual')
    xlabel('$y$','Interpreter','latex')
    ylabel('$x$','Interpreter','latex')
    drawnow

    %%%%%%%%%%%%%%%%% Compute second member %%%%%%%%%%%%%%%%%%%%%%

    [nx,ny]=size(Resid);
    Nelem=SubMesh.Nelem;
    Ndof=2*(SubMesh.NNodeTot);
    S=zeros(Ndof,1);

    for ii=1:Nelem
        iinode=SubMesh.TRI(ii,:);
        xmin=floor(min(real(SubMesh.Znode(iinode))));
        xmax=floor(max(real(SubMesh.Znode(iinode))));
        ymin=ceil(min(imag(SubMesh.Znode(iinode))));
        ymax=ceil(max(imag(SubMesh.Znode(iinode))));
        x=[xmin:xmax];
        y=[ymin:ymax];
        [Y,X]=meshgrid(y,x);
        IN=inpolygon(Y,X,imag(SubMesh.Znode(iinode)),real(SubMesh.Znode(iinode)));
        ind=find(IN);
        ix=X(ind);
        iy=Y(ind);
        indim=ix+(iy-1)*nx;
        idof=[2*iinode(1)-1,2*iinode(1),2*iinode(2)-1,2*iinode(2),2*iinode(3)-1,2*iinode(3)];
        f(1)=sum(Gx1(indim).*Resid(indim));
        f(2)=sum(Gy1(indim).*Resid(indim));
        f(3)=sum(Gx2(indim).*Resid(indim));
        f(4)=sum(Gy2(indim).*Resid(indim));
        f(5)=sum(Gx3(indim).*Resid(indim));
        f(6)=sum(Gy3(indim).*Resid(indim));
        for ij=1:6
            S(idof(ij))=S(idof(ij))+f(ij);
        end
    end

    %dU=Mregul(1:4,1:4)\S(1:4);
    dU=M(1:4,1:4)\S(1:4);
    U(1:4)=U(1:4)+dU;

    if (sqrt(mean(dU(1:2:end))^2+mean(dU(2:2:end))^2)<1.e-8)|((resnorm>resnorm0)&(iter>itermin))
        break
    end

end

figure
colormap(hot)
imagesc((im1-meanref).*(T>0))
axis image

figure
colormap(hot)
imagesc((jm1-mean(jm1(indin))).*(T>0))
axis image
hold on
triplot(SubMesh.TRI,imag(SubMesh.Znode),real(SubMesh.Znode),'k')




           



