%%%% PlotDiscont
% Program to plot the discontinuity of displacement along a crack
%


for ii=1:Mesh.NBoundary
    icrack2(ii)=strcmp('Crack2',Mesh.Type{ii});
end
ib=find(icrack2);
ia=Mesh.BParent(ib);


for ii=1:length(ib);

    inode1=Mesh.INodeEdge(ia(ii))-1+[1:Mesh.NNodeEdge(ia(ii))];
    inode2=[inode1(1),Mesh.INodeEdge(ib(ii))-1+[Mesh.NNodeEdge(ib(ii)):-1:1],inode1(end)];

    U1=U(2*inode1-1);
    V1=U(2*inode1);
    U2=U(2*inode2-1);
    V2=U(2*inode2);
    Z1=Mesh.Znode(inode1);
    Z2=Mesh.Znode(inode2);

    figure
    plot(real(Z1),-(U1-U2),'k-')
    hold on
    %plot(real(Z1),U2,'k:')
    plot(real(Z1),V1-V2,'r-')
    %plot(real(Z1),V2,'r:')
    xlim([100 900])
    xlabel('$y$','Interpreter','latex')
    ylabel('$\Delta U$  (pix.)','Interpreter','latex')
    legend('$-\Delta U_x$','$\Delta U_y$')

    % figure
    % plot(Z1,'k.-')
    % hold on
    % plot(Z2,'r.-')

    figure
    quiver(imag(Z1),real(Z1),V1-V2,U1-U2,'Color','r')
    axis ij
    axis image
    xlim([200 500])
    ylim([100 900])
    line(imag(Z1),real(Z1),'Color','k')
    xlabel('$y$','Interpreter','latex')
    ylabel('$x$','Interpreter','latex')

end

