close all
clear all
FlagRenewCenter=0;
FlagScale=0;

Path1='C:/Users/Stephane/Im_Data/HorsPlan2/Scale/';
FileName='IMG_5364.jpg';
im=imread([Path1,FileName]);
im=sum(double(im),3);

figure
imagesc(im)
colormap(gray)
hold on
if FlagRenewCenter
    title('TopRight to BottomLeft')
    [Y,X]=ginput(2);
    hold on
    TopRight=X(1)+i*Y(1);
    line(Y,X,'Color','r');
    title('TopLeft to BottomRight')
    [Y2,X2]=ginput(2);
    TopLeft=X2(1)+i*Y2(1);
    line(Y2,X2,'Color','r');
    title('Point SGR laser measurement')
    [Y3,X3]=ginput(1);
    SGR=X3+i*Y3;
    a1=(Y(2)-Y(1))/(X(2)-X(1));
    b1=Y(1)-a1*X(1);
    a2=(Y2(2)-Y2(1))/(X2(2)-X2(1));
    b2=Y2(1)-a2*X2(1);
    Xcenter=(b2-b1)/(a1-a2);
    Ycenter=a1*Xcenter+b1;
    Center=Xcenter+i*Ycenter;
    title('Point extreme right')
    [Y4,X4]=ginput(1);
    Right=Xcenter+i*Y4(1);
    plot(Ycenter,Xcenter,'ko','MarkerFaceColor','r')
    plot(imag(SGR),real(SGR),'ko','MarkerFaceColor','r')
    plot(imag(Right),real(Right),'ko','MarkerFaceColor','r')
    plot(imag(TopRight),real(TopRight),'ko','MarkerFaceColor','r')
    plot(imag(TopLeft),real(TopLeft),'ko','MarkerFaceColor','r')
    disp(sprintf('Center  %5.0g',Center));
    save('Center.mat','Center','Right','TopLeft','TopRight','SGR')
else
    load('Center.mat');
end

% Reference
Path1='C:/Users/Stephane/Im_Data/HorsPlan2/Scale/';
FileName='IMG_5364-IMG_5366-Mesh.mat';
DistanceRef=40;% 
load([Path1,FileName],'Mesh','Job','U');
ROI=Job.ROI;clear Job

Z=Mesh.Znode+ROI(1)-1+i*ROI(2)-i;
n=Mesh.NNodeTot;
d=abs(Z-Center);
[d0,iicenter]=min(d); 
d=abs(Z-Right);
[d0,iiright]=min(d); 
d=abs(Z-SGR);
[d0,iisgr]=min(d); 
d=abs(Z-TopLeft);
[d0,iitopleft]=min(d); 
d=abs(Z-TopRight);
[d0,iitopright]=min(d); 
clear d
% disp(sprintf('Distance %3.0f pixels',round(d0)))
% disp(sprintf('Numero de noeud = %g',ii))
% disp(sprintf('   x = %5.0f',round(real(Z(ii)))))
% disp(sprintf('   y = %5.0f',round(imag(Z(ii)))))
ii=[iicenter,iiright,iitopright,iitopleft,iisgr];
plot(imag(Z(ii)),real(Z(ii)),'bo','MarkerFaceColor','b');
Uxref=zeros(5,1);
Uyref=zeros(5,1);
Uxref(:)=U(2*ii(:)-1);
Uyref(:)=U(2*ii(:));


if FlagScale
    Path1='C:\Users\Stephane\Im_Data\HorsPlan2\Scale\';
    nfil=3;
else
    Path1='C:\Users\Stephane\Im_Data\HorsPlan2\Fire_test\';
    nfil=72;%75;
    Ux=zeros(5,nfil);
    Uy=zeros(5,nfil);
    d=zeros(5,nfil);
end

for ifil=1:nfil
     if FlagScale
         FileName=['IMG_5364-IMG_5',num2str(ifil+364,'%03g')];
     else
        FileName=['IMG_5374-IMG_5',num2str(ifil+374,'%03g')];
     end
    FullFileName=[Path1,FileName,'-Mesh.mat'];
    if size(dir(FullFileName),1)==0
        Ux(:,ifil)=nan(5,1);
        Uy(:,ifil)=nan(5,1);
        d(:,ifil)=nan(5,1);
    else       
        load(FullFileName);
        Ux(:,ifil)=U(2*ii(:)-1);
        Uy(:,ifil)=U(2*ii(:));
        d(:,ifil)=(Ux(:,ifil).*Uxref(:)+Uy(:,ifil).*Uyref(:))...
            ./(Uxref(:).^2+Uyref(:).^2)*DistanceRef;
    end
end

load('C:\Users\Stephane\Im_Data\HorsPlan2\SGRData.mat')
h=figure;
plot(time(2:length(d)+1),d(1,:),'r.-','LineWidth',2);%,'MarkerFaceColor','r')
hold on
plot(time2,DeflecCenter-1.1236,'k.-')
title('Center')
xlabel('Time  (min)')
ylabel('Deflection  (mm)')
filesave=['C:\Users\Stephane\Im_Data\HorsPlan2\','Center.jpg'];
%saveas(h,filesave);

h=figure;
plot(time(2:length(d)+1),d(2,:),'r.-','LineWidth',2);%,'MarkerFaceColor','r')
hold on
plot(time2,DeflecRight,'k.-')
title('Right Free Edge')
xlabel('Time  (min)')
ylabel('Deflection  (mm)')
filesave=['C:\Users\Stephane\Im_Data\HorsPlan2\','RighFreeEdge.jpg'];
%saveas(h,filesave);

h=figure;
plot(time(2:length(d)+1),d(3,:),'r.-','LineWidth',2);%,'MarkerFaceColor','r')
hold on
plot(time2,DeflecTopRight,'k.-')
title('Top Right Corner')
xlabel('Time  (min)')
ylabel('Deflection  (mm)')
filesave=['C:\Users\Stephane\Im_Data\HorsPlan2\','TopRight.jpg'];
%saveas(h,filesave);

h=figure;
plot(time(2:length(d)+1),d(4,:),'r.-','LineWidth',2);%,'MarkerFaceColor','r')
hold on
plot(time2,DeflecTopLeft,'k.-')
title('Top Left Corner')
xlabel('Time  (min)')
ylabel('Deflection  (mm)')
filesave=['C:\Users\Stephane\Im_Data\HorsPlan2\','TopLeft.jpg'];
%saveas(h,filesave);

h=figure;
plot(time(2:length(d)+1),d(5,:),'r.-','LineWidth',2);%,'MarkerFaceColor','r')
hold on
plot(time,LaserSGR+2,'k.-')
title('SGR Measurement')
xlabel('Time  (min)')
ylabel('Deflection  (mm)')
filesave=['C:\Users\Stephane\Im_Data\HorsPlan2\','LaserSGR.jpg'];
%saveas(h,filesave);



