function  [K,M,P,D]=StiffElem(Z,mu,lambda,Damage)

if nargin<4
    Damage=0;
end
Z2=Z(2)-Z(1);
Z3=Z(3)-Z(1);
x2=real(Z2);
x3=real(Z3);
y2=imag(Z2);
y3=imag(Z3);
N=[x2,x3;y2,y3];
D=det(N);
%Orient=sign(D);


% eps=M.[U1x;U1y;U2x;U2y;U3x;U3y];
% eps Voigt (epsxx,epsyy,sqrt(2)*epsxy)
M(1,:)=          [-y3+y2,    0, y3,  0,-y2,  0];
M(2,:)=          [0     ,x3-x2,  0,-x3,  0, x2];
M(3,:)=sqrt(2)/2*[ x3-x2,y2-y3,-x3, y3, x2,-y2];
M=M/D; 
Treps=M(1,:)+M(2,:);
Mdev=M-.5*[1;1;0]*Treps;

% sig=P*[U];
P=(1-Damage)*(2*mu*Mdev+lambda*[1;1;0]*Treps);

%stiffness;
K=0.5*abs(D)*M'*P;