% function    AdaptMesh(d,WorkFile,NewMeshFile)
clear all
close all

% Create a new mesh to comply with 
% the outer boundary read in WorkFile.Polygon 
% and an additional boundary read in WorkFile.CrackPath


d=4;

WorkFile.Polygon   = './TMP/Polygon.mat';
WorkFile.CrackPath{1} = './TMP/CrackPath.mat' ;
%WorkFile.CrackPath{2} = './TMP/CrackPath2.mat';
%WorkFile.CrackPath{3} = './TMP/CrackPath3.mat';
NewMeshFile        = './TMP/Mesh2.mat';

ZEdge=zeros(4,40);
load(WorkFile.Polygon)
ZEdge(1,1:nZ)=Z;
NNodeEdge(1)=nZ;
m=size(WorkFile.CrackPath,2);
for ii=1:m
    load(WorkFile.CrackPath{ii})
    ZEdge(ii+1,1:Npt+2)=Z;
    NNodeEdge(ii+1)=Npt+2;
end

for ii=1:m+1
    Boundary(ii).Z=ZEdge(ii,1:NNodeEdge(ii));
    Boundary(ii).NNode=NNodeEdge(ii);
end
Boundary(1).Type{1}='Outer';
Boundary(1).Close(1)=1;
Boundary(1).RefPoly=RefPoly;
for ii=2:m+1
    Boundary(ii).Type{1}='Crack';
    Boundary(ii).Close=0;
end

for ii=3:m+1
    Z1=Boundary(ii).Z(1);
    [d1,ij10]=min(abs(Boundary(2).Z(:)-Z1));
    Z2=Boundary(ii).Z(Boundary(ii).NNode);
    [d2,ij20]=min(abs(Boundary(2).Z(:)-Z2));
    if d1<d2
        ij=1;
        ijp=2;
        ij0=ij10;
    else
        ij=Boundary(ii).NNode;
        ijp=ij-1;
        ij0=ij20;
        d1=d2;
        Z1=Z2;
    end
    ij01=ij0+1;
    if ij01>Boundary(2).NNode
        ij0p=ij0-1;
    else
        d2=abs(Boundary(2).Z(ij01)-Z1);
        ij02=ij0-1;
        if ij02<0
            ij0p=ij01;
        else
            d3=abs(Boundary(2).Z(ij01)-Z1);
            if d2<d3
                ij0p=ij01;
            else
                ij0p=ij02;
            end
        end
    end
    Z0=Boundary(2).Z(ij0);
    Z0p=Boundary(2).Z(ij0p);
    zzz=real((Z1-Z0)/(Z0p-Z0));
    Z00=Z0+zzz*(Z0p-Z0);
    Boundary(ii).Z(ij)=Z00;
    Boundary(2).Z(ij0)=Z00;
end

FlagPlot=1;
Mesh=SimpleMesh2(d,Boundary,FlagPlot);

for ii=1:Mesh.NBoundary
    iCrack(ii)=strcmp(Mesh.Type{ii},'Crack');
end
indCrack=find(iCrack);
%iNewBoundary=Mesh.NBoundary+1;
for ii=1:length(indCrack)
    ij=indCrack(ii);
    iza=[Mesh.INodeEdge(ij):Mesh.INodeEdge(ij)+Mesh.NNodeEdge(ij)-1];
    za=Mesh.Znode(iza);
    n=length(iza);
    nbond(1:n-1)=i*(za(2:n)-za(1:n-1))./abs(za(2:n)-za(1:n-1));
    nsite(2:n-1)=(nbond(2:n-1)+nbond(1:n-2))*.5;
    nsite(2:n-1)=nsite(2:n-1)/abs(nsite(2:n-1));
    nodenumber(:,1)=iza(:);                           % from crack face 1
    nodenumber(2:end-1,2)=Mesh.NNodeTot+[n-2:-1:1]';  % from crack face 2
    nodenumber(1,2)=nodenumber(1,1);
    nodenumber(end,2)=nodenumber(end,1);
    Mesh.Znode(Mesh.NNodeTot+1:Mesh.NNodeTot+n-2)=za(n-1:-1:2);
    Mesh.NBoundary=Mesh.NBoundary+1;
    Mesh.NNodeEdge(Mesh.NBoundary)=n-2;%Mesh.NNodeEdge(Mesh.NBoundary-1);
    Mesh.INodeEdge(Mesh.NBoundary)=Mesh.NNodeTot+1;
    Mesh.NNodeTot=Mesh.NNodeTot+n-2;
    Mesh.Close(Mesh.NBoundary)=0;%Mesh.Close(Mesh.NBoundary-1);
    Mesh.Type{Mesh.NBoundary}='Crack2';%Mesh.Type{Mesh.NBoundary-1};    
    Mesh.BParent(Mesh.NBoundary)=ij;
    %Mesh.Close(Mesh.NBoundary-1)=0;
    %Mesh.Type{Mesh.NBoundary-1}='Crack2';
    %Mesh.NNodeEdge(Mesh.NBoundary-1)=n-2;
    %
    itri=zeros(size(Mesh.TRI));
    for ji=2:n-1
        k=nodenumber(ji,1);
        ind=find(Mesh.TRI==k);
        itri(ind)=1;
    end
    ntri=sum(itri,2);
    ind=find(ntri>=1);
    for ji=1:length(ind)
        jj=ind(ji);
        k1=Mesh.TRI(jj,1);
        k2=Mesh.TRI(jj,2);
        k3=Mesh.TRI(jj,3);
        zcenter=(Mesh.Znode(k1)+Mesh.Znode(k2)+Mesh.Znode(k3))/3.;
        if ntri(jj)==2
            ik=find(itri(jj,:)==1);
            k4=Mesh.TRI(jj,ik(1));
            k5=Mesh.TRI(jj,ik(2));
            k6=min(k4,k5);
            j6=k6-Mesh.INodeEdge(ij)+1;
            zedge=(Mesh.Znode(k4)+Mesh.Znode(k5))/2.;
            proj=real((zcenter-zedge)*conj(nbond(j6)));
            if proj<0
                i4=find(iza==k4);
                Mesh.TRI(jj,ik(1))=nodenumber(i4,2);
                i5=find(iza==k5);
                Mesh.TRI(jj,ik(2))=nodenumber(i5,2);
            end
        else
            ik=find(itri(jj,:)==1);
            k4=Mesh.TRI(jj,ik);
            j4=k4-Mesh.INodeEdge(ij)+1;
            zedge=Mesh.Znode(k4);
            proj=real((zcenter-zedge)*conj(nsite(j4)));
            if proj<0
                i4=find(iza==k4);
                Mesh.TRI(jj,ik)=nodenumber(i4,2);
            end
        end
    end
end

% New stamp
Mesh.RefMesh=fix(clock);

save(NewMeshFile,'Mesh');
            
        

    
    
    
    




