function TestMain4(Job,Param,FlagVisu)

%
% Same as TestMain but with mesh and boundary saved as Structure
%
% TO BE DONE: SPLIT FILE NAMES IN PREFIX, NUM, SUFFIX + specify # digits as
% a substruct with fields
% Job.Ref.name, Job.Ref.prefix, Job.Ref.nbdigit, Job.Ref.numref, 
% Job.Ref.sufix, Job.Ref.ext
%             SAVE PACKAGE OF FILES (mask, damage, ..)
%             AUTOMATIC EDGE
%             NEUMANN cond.
%
set(0,'DefaultAxesFontName','Times','DefaultAxesFontSize',20,'DefaultTextInterpreter','tex');
%set(0,'DefaultTextInterpreter','latex');

%%
if nargin>0
    FlagBatch=1;
    NewJob=Job;
    FlagVisuStr=0;
%     NewJob.Def=FileNameDef0;
%     k=strfind(NewJob.Ref,'/');
%     NewJob.Path=FileNameRef0(1:k(end));
%     NewJob.ROI='';% '' means use the same as previous
%     NewJob.Mask=FileMask;
%     NewJob.UseMask=~isempty(FileMask);
%     if NewJob.UseMask==0
%         NewJob.RefMask=zeros(1,6);
%     else
%         load(NewJob.Mask,'RefMask')
%         NewJob.RefMask=RefMask;
%     end
%     if isempty(FileMesh)
%         NewJob.Mesh='';
%         NewJob.RefPoly=zeros(1,6);
%         NewJob.RefMesh=zeros(1,6);
%     else
%         NewJob.Mesh=['./TMP/',FileMesh];
%         load(NewJob.Mesh)
%         NewJob.RefPoly=Mesh.RefPoly;
%         NewJob.RefMesh=Mesh.RefMesh;
%     end
%     NewJob.IniU=FileIniU;
else
    close all;
    clear all;
    FlagBatch=0;
    FlagVisuStr=0;
    DefaultPath='c:/Im_Data/';
    NewJob.Ref=DefaultPath;
    NewJob.Def=DefaultPath;
    NewJob.Path=DefaultPath;
    NewJob.ROI='';% '' means use the same as previous
    NewJob.UseMask=NaN; %0=no mask; 1=use mask (propose a name in NewJob.Mask; NaN= don't know, use LastJob as initial prop
    NewJob.Mask='';
    NewJob.RefMask=zeros(1,6);
    NewJob.Poly='';
    NewJob.RefPoly=zeros(1,6);
    NewJob.Mesh='';
    NewJob.RefMesh=zeros(1,6);
    NewJob.IniU='';
end

% Internal variables to be moved into NewJob
WorkFile.Mask           = './TMP/Mask.mat';    % in ChooseMask used as default filename
WorkFile.Polygon        = './TMP/Polygon2.mat'; % in ChoosePoly used as default filename
WorkFile.Mesh           = './TMP/Mesh2.mat';   % in ChooseMesh used as default filename
WorkFile.CrackPath{1}   = './TMP/CrackPath';
WorkFile.CrackPath{2}   = './TMP/CrackPath2';
WorkFile.CrackPath{3}   = './TMP/CrackPath3';
WorkFile.CrackEndPoints = './TMP/CrackEndPoints';

% Internal parameters (Never to be changed)
WorkFile.LastJob        = './TMP/LastJob.mat';
WorkFile.ImRef          = './TMP/ImRef.mat';
WorkFile.ImDef          = './TMP/ImDef.mat';
WorkFile.ImMask         = './TMP/ImMask.mat';
WorkFile.ImMesh         = './TMP/ImMesh.mat';
WorkFile.Rigid          = './TMP/Rigid.mat';
WorkFile.Edge           = './TMP/Edge.mat';
WorkFile.Elast          = './TMP/Elast.mat';
WorkFile.Psi            = './TMP/Psi';
WorkFile.RigidWeight    = './TMP/RigidWeight';
WorkFile.ResultFileM    = '';
WorkFile.ResultFileI    = '';

if FlagBatch
    WorkFile.Mesh           = NewJob.Mesh;
    %NewJob.Poly             = WorkFile.Polygon;
else
    FlagVisu=1;
    Param.InterpMethod='*cubic';% choose '*cubic' or '*linear'
    Param.Itermin=5;
    Param.Itermax=1000;
    Param.IterDamage=0;
    Param.Lregul=10;
    Param.Lreguledge=Param.Lregul/2;
    Param.Young=1;
    Param.nu=0.01;
    Param.CvCriter=1.e-4;
end

%% %%%%%%%%%%%  READ REF FILE  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%

[LastJob,NewJob,im1]=Choose_Ref(WorkFile,FlagBatch,NewJob,Param,FlagVisu);

%% %%%%%%%%%%%  READ Mask FILE  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%

[NewJob,Mask]=Choose_Mask(WorkFile,FlagBatch,LastJob,NewJob,im1,FlagVisu);

%% %%%%%%%%%%%%%%% SELECT POLYGON %%%%%%%%%%%%%%%%%%%%%%

[NewJob,Boundary]=Choose_Poly(WorkFile,FlagBatch,LastJob,NewJob,im1,FlagVisu);

%% %%%%%%%%%%%%%%% SELECT MESH %%%%%%%%%%%%%%%%%%%%%%

[NewJob,Mesh]=Choose_Mesh(WorkFile,FlagBatch,LastJob,NewJob,Boundary,im1,FlagVisu);
load(WorkFile.ImMesh,'RefMesh','T','W1','W2','W3');


if FlagVisu
	vec=[1 2 5 10 20 50 100 200 500];
	answ=menu('Reg. length','1','2','5','10','20','50','100','200','500');
	Param.Lregul=vec(answ);
	Param.Lreguledge=vec(answ)/8;
end

%% %%%%%%%%%%%%%%% COMPUTE RIGIDITY MATRIX %%%%%%%%%%%%%%%%%%%%%%

D=zeros(Mesh.Nelem,1);
[Mtot,Mregul]=Compute_StiffnessMatrices(WorkFile,NewJob,LastJob,Param,im1,D);

%% %%%%%%%%%%%%%%% CHOOSE DEFORMED FILE %%%%%%%%%%%%%%%%%%%%%%

[NewJob,imdef]=Choose_Def(FlagBatch,NewJob,LastJob,WorkFile,im1,Param,FlagVisu);

%% %%%%%%%%%%%%%%% INITIALIZE DISPLACEMENT %%%%%%%%%%%%%%%%%%%%%%
[NewJob,U]=SetInitialDisp(FlagBatch,WorkFile,NewJob,im1,imdef,Param);

%% =============== PG CORE ============================

%------------------------------ Modif Adrien ------------------------------%
Param.Iterfin = Param.Itermax;
[U,Resid,Param] = Compute_core(FlagBatch,FlagVisu,WorkFile,NewJob,im1,imdef,U,Mtot,Mregul,Param);
%---------------------------- Fin Modif Adrien ----------------------------%

%% %%%%%%%%%%%%%%% Plot strains %%%%%%%%%%%%%%%%%%%%%%%%%

if FlagVisuStr
    FlagPlot=zeros(1,11);FlagPlot(2)=1;FlagPlot(5:6)=1;
    epsxx=ViewStrain(U, NewJob.Mesh, WorkFile.ImMesh, NewJob.ROI, D, Param, FlagPlot);
end

%% %%%%%%%%%%%%%%% Save results %%%%%%%%%%%%%%%%%%%%%%

Uxpix=InterpMeshNode(WorkFile,NewJob,U(1:2:end-1));
Uypix=InterpMeshNode(WorkFile,NewJob,U(2:2:end));

%% ====================== end of pg core ===========================

%% %%%%%%%%%%%%%%% Adjust  Damage %%%%%%%%%%%%%%%%%%%%%%

for ii=1:Param.IterDamage
    FlagPlot=zeros(1,11);
    epsxx=ViewStrain(U, NewJob.Mesh, WorkFile.ImMesh, NewJob.ROI, D, Param, FlagPlot);
    D=1-exp(-(max(epsxx,0)/0.001).^2);
    TriDICElast2(WorkFile,NewJob,Param.nu,D);
    load(WorkFile.Rigid,'M');
    load(WorkFile.Elast,'K');
    load(WorkFile.Edge,'Kedge')
    load(WorkFile.RigidWeight)
    Mregul=Ael*K+Aed*Kedge; % !!! Beware weights are not adjusted to damage
    Mtot=Mregul+M;
    [U,Resid]=Compute_core(FlagBatch,FlagVisu,WorkFile,NewJob,im1,imdef,U, Mtot,Mregul,Param);

    if FlagVisu
        FlagPlot=zeros(1,11);FlagPlot(1:2)=1;FlagPlot(5:6)=1;
        epsxx=ViewStrain(U, NewJob.Mesh, WorkFile.ImMesh, NewJob.ROI, D, Param, FlagPlot);
        if ii<Param.IterDamage
            pause
            for ij=1:sum(FlagPlot)
                close
            end
        end
    end
end

%% End of computation 

if FlagVisu
    load(WorkFile.Elast,'K')
    f=K*U;
    f=abs(f(1:2:end)+i*f(2:2:end));
    imf=InterpMeshNode(WorkFile,NewJob,f);
    Handle=ShowIm(imf,'Mech. residual','ROI',NewJob.ROI,'Colormap','hot','Position',[.14 .14 .7 .73]);
end

%% Save results 

i0=max(findstr('/',NewJob.Ref));
i1=max(findstr('.',NewJob.Ref));
Strref=NewJob.Ref(i0+1:i1-1);
i0=max(findstr('/',NewJob.Def));
i1=max(findstr('.',NewJob.Def));
Strdef=NewJob.Def(i0+1:i1-1);
WorkFile.ResultFileM = [NewJob.Path,Strref,'-',Strdef,'-Mesh-',num2str(Param.Lregul)];
WorkFile.ResultFileI = [NewJob.Path,Strref,'-',Strdef,'-Image-',num2str(Param.Lregul)];
disp('Result files :');
disp(sprintf('  %s',WorkFile.ResultFileM));
disp(sprintf('  %s',WorkFile.ResultFileI));

Job=NewJob;
load(NewJob.Mesh);
save(WorkFile.ResultFileM,'Mesh','U','Job')
ROI=NewJob.ROI;
coorx=[ROI(1),ROI(3)];
coory=[ROI(2),ROI(4)];
load(WorkFile.ImMask)
Uxpix=InterpMeshNode(WorkFile,NewJob,U(1:2:end-1));
Uypix=InterpMeshNode(WorkFile,NewJob,U(2:2:end));
save(WorkFile.ResultFileI,'ROI','coorx','coory','im1','Mask','Resid','Uxpix','Uypix','Job','Param')

if ~FlagBatch
    %answer=inputdlg('1 = Yes; 0 = No','New detection of crack path ?',1,{'0'});
     clear answer;answer{1}='0';
    if size(answer,1)==0
        FlagNewCrack=0;
    else
        FlagNewCrack=str2num(answer{1});
    end
    if FlagNewCrack
        figure
        colormap(hot)
        imagesc(coory,coorx,Resid)
        load(NewJob.Mesh);
        d=Mesh.CharLength;
        icrack=1;
        FlagRefresh=1;
        FlagPlot=1;
        FlagFinalPlot=1;
        [Z]=FindCrack(d,WorkFile,icrack,ROI,FlagRefresh,FlagPlot,FlagFinalPlot);
        TestAdaptMesh;
    end
end
       
        
