close all
clear all
set(0,'DefaultAxesFontName','Times','DefaultAxesFontSize',24,'DefaultTextInterpreter','latex');

addpath('./AVS2Matlab');
imsize=300*[1 1]; % embedding image size


% fid=fopen('./AVS2Matlab/1boulon-test.avs','r');
% fid=fopen('./AVS2Matlab/1boulon-test-2pas_p1.avs','r');
% fid=fopen('./AVS2Matlab/1boulon-test-2pas_p2.avs','r');
 fid=fopen('./AVS2Matlab/1boulon-test.avs','r');
% fid=fopen('./AVS2Matlab/1boulon-test2.avs','r');
[xcoor,mail,chpo1,chml,cara,error1] = Read1AVS(fid);

nbno=size(xcoor,1);
nbel=size(mail{1}.MAIL,1);
disp(sprintf('Mesh type = %s',mail{1}.TYPE));
disp(sprintf('  Number of nodes    = %g',nbno));
disp(sprintf('  Number of elements = %g',nbel));

Z=xcoor(:,1)+i*xcoor(:,2);
TRI=mail{1}.MAIL(:,:);


% figure
% triplot(TRI,imag(Z),real(Z),'k');
% axis ij;axis image

Znode=Z-min(xcoor(:,1))-i*min(xcoor(:,2));
a=[max(real(Znode)),max(imag(Znode))];
scal=max(a(:)./imsize(:));
Znode=Znode/scal*.85;
Znode=Znode-mean(Znode)+(imsize(1)+i*imsize(2))*.5;
ROI=[1 1 imsize(1) imsize(2)];

[T,W1,W2]=Pixel2Tri(TRI,Znode,ROI);

if size(chpo1{1}{1}.XVAL,2)==3
    Nodevalue=chpo1{1}{1}.XVAL(:,1);
    imx=InterpMeshNode(ROI,T,W1,W2,TRI,Nodevalue);
    Nodevalue=chpo1{1}{1}.XVAL(:,2);
    imy=InterpMeshNode(ROI,T,W1,W2,TRI,Nodevalue);
    Nodevalue=chpo1{1}{1}.XVAL(:,3);
    imz=InterpMeshNode(ROI,T,W1,W2,TRI,Nodevalue);
elseif size(chpo1{1}{1}.XVAL,2)==1
    Nodevalue=chpo1{1}{1}.XVAL(:,1);
    imx=InterpMeshNode(ROI,T,W1,W2,TRI,Nodevalue);
end

figure
triplot(TRI,imag(Znode),real(Znode),'k');
axis ij;axis image
xlim([1 imsize(1)]);
ylim([1 imsize(2)]);
set(gca,'Position',[0.15    0.15    0.75    0.72])
xlabel('$x$');
ylabel('$y$');
title('Mesh')

if size(chpo1{1}{1}.XVAL,2)==3
    figure
    colormap(hot)
    imagesc(imx)
    xlim([1 imsize(1)]);
    ylim([1 imsize(2)]);
    axis image
    set(gca,'Position',[0.15    0.15    0.75    0.72])
    xlabel('$x$');
    ylabel('$y$');
    if size(chpo1{1}{1}.UNIT,1)==0
        title(['$',chpo1{1}{1}.COMP,'_x$'])
    else
        title(['$',chpo1{1}{1}.COMP,'_x$   (',chpo1{1}{1}.UNIT,')'])
    end
    figure
    colormap(hot)
    imagesc(imy)
    xlim([1 imsize(1)]);
    ylim([1 imsize(2)]);
    axis image
    set(gca,'Position',[0.15    0.15    0.75    0.72])
    xlabel('$x$');
    ylabel('$y$');
    if size(chpo1{1}{1}.UNIT,1)==0
        title(['$',chpo1{1}{1}.COMP,'_y$'])
    else
        title(['$',chpo1{1}{1}.COMP,'_y$   (',chpo1{1}{1}.UNIT,')'])
    end
    figure
    colormap(hot)
    imagesc(imz)
    xlim([1 imsize(1)]);
    ylim([1 imsize(2)]);
    axis image
    set(gca,'Position',[0.15    0.15    0.75    0.72])
    xlabel('$x$');
    ylabel('$y$');
    if size(chpo1{1}{1}.UNIT,1)==0
        title(['$',chpo1{1}{1}.COMP,'_z$'])
    else
        title(['$',chpo1{1}{1}.COMP,'_z$   (',chpo1{1}{1}.UNIT,')'])
    end
elseif size(chpo1{1}{1}.XVAL,2)==1
    figure
    colormap(hot)
    imagesc(imx)
    xlim([1 imsize(1)]);
    ylim([1 imsize(2)]);
    axis image
    set(gca,'Position',[0.15    0.15    0.75    0.72])
    xlabel('$x$');
    ylabel('$y$');
    if size(chpo1{1}{1}.UNIT,1)==0
        title(['$',chpo1{1}{1}.COMP,'$'])
    else
        title(['$',chpo1{1}{1}.COMP,'$   (',chpo1{1}{1}.UNIT,')'])
    end
end