function  TriDICEdge2(WorkFile,NewJob)

load(NewJob.Mesh,'Mesh');

for ii=1:Mesh.NBoundary
    iOuter(ii)=strcmp(Mesh.Type{ii},'Outer')|strcmp(Mesh.Type{ii},'Inner');
    iCrack(ii)=strcmp(Mesh.Type{ii},'Crack')|...
           strcmp(Mesh.Type{ii},'Crack2');
end
indOuter=find(iOuter);
indCrack=find(iCrack);

ind1=[];
ind2=[];
kel=[];

for ibou=1:length(indOuter)
    jbou=indOuter(ibou);
    m=Mesh.NNodeEdge(jbou);
    inode=[Mesh.INodeEdge(jbou):Mesh.INodeEdge(jbou)+m-1];
    Z=Mesh.Znode(inode);

    dZp=[Z(2:m);Z(1)]-Z;
    dZm=[dZp(m);dZp(1:m-1)];
    d2Z=imag(conj(dZp).*dZm);

    for ij=1:Mesh.NNodeEdge(jbou)
        ijp=mod(ij,m)+1;
        ijm=mod(ij+m-2,m)+1;
        ik=inode(ij);
        ikp=inode(ijp);
        ikm=inode(ijm);
        ind1=cat(1,ind1,2*[ik ;ik;ik ]-1);
        ind2=cat(1,ind2,2*[ikp;ik;ikm]-1);
        kel=[kel;-conj(dZp(ij))./abs(dZp(ij));...
                  conj(dZp(ij))./abs(dZp(ij))+conj(dZm(ij))./abs(dZm(ij));...
                 -conj(dZm(ij))./abs(dZm(ij))];
        ind1=cat(1,ind1,2*[ik ;ik;ik ]);
        ind2=cat(1,ind2,2*[ikp;ik;ikm]);
        kel=[kel;-conj(dZp(ij))./abs(dZp(ij));...
                  conj(dZp(ij))./abs(dZp(ij))+conj(dZm(ij))./abs(dZm(ij));...
                 -conj(dZm(ij))./abs(dZm(ij))];
    end
end

for ibou=1:length(indCrack)
    jbou=indCrack(ibou);
    m=Mesh.NNodeEdge(jbou);
    inode=[Mesh.INodeEdge(jbou):Mesh.INodeEdge(jbou)+m-1];
    Z=Mesh.Znode(inode);

    dZp=Z(2:m)-Z(1:m-1);
    dZm(2:m)=dZp(1:m-1);

    for ij=2:m-1
%         ijp=ij+1;
%         ijm=ij-1;
        ik=inode(ij);
        ikp=inode(ij+1);
        ikm=inode(ij-1);
        ind1=cat(1,ind1,2*[ik ;ik;ik ]-1);
        ind2=cat(1,ind2,2*[ikp;ik;ikm]-1);
        kel=[kel;-conj(dZp(ij))./abs(dZp(ij));...
                  conj(dZp(ij))./abs(dZp(ij))+conj(dZm(ij))./abs(dZm(ij));...
                 -conj(dZm(ij))./abs(dZm(ij))];
        ind1=cat(1,ind1,2*[ik ;ik;ik ]);
        ind2=cat(1,ind2,2*[ikp;ik;ikm]);
        kel=[kel;-conj(dZp(ij))./abs(dZp(ij));...
                  conj(dZp(ij))./abs(dZp(ij))+conj(dZm(ij))./abs(dZm(ij));...
                 -conj(dZm(ij))./abs(dZm(ij))];
    end
end




m=2*Mesh.NNodeTot;
K=sparse(ind1,ind2,kel,m,m);
Kedge=real(K'*K);

RefMesh=Mesh.RefMesh;
save(WorkFile.Edge,'Kedge','RefMesh')







