function  TriDICEdge3(WorkFile,NewJob)

load(NewJob.Mesh,'Mesh');

for ii=1:Mesh.NBoundary
    iOuter(ii)=strcmp(Mesh.Type{ii},'Outer')|strcmp(Mesh.Type{ii},'Inner');
    iCrack(ii)=strcmp(Mesh.Type{ii},'Crack')|...
           strcmp(Mesh.Type{ii},'Crack2');
end
indOuter=find(iOuter);
indCrack=find(iCrack);

ind1=[];
ind2=[];
kel=[];

for ibou=1:length(indOuter)
    jbou=indOuter(ibou);
    m=Mesh.NNodeEdge(jbou);
    inode=Mesh.INodeEdge(jbou)+[0:m-1];
    Z=Mesh.Znode(inode);

    dZp=[Z(2:m);Z(1)]-Z;
    dZp=dZp./(abs(dZp).^2); 
    dZm=-[dZp(m);dZp(1:m-1)];
    %d2Z=imag(conj(dZp).*dZm);

    % first loop on linear springs
    for ij=1:Mesh.NNodeEdge(jbou)
        ijp=mod(ij,m)+1;
        ijm=mod(ij+m-2,m)+1;
        ik=inode(ij);
        ikp=inode(ijp);
        ikm=inode(ijm);
        ael=abs(dZp(ij))^2;
        ind1=cat(1,ind1,2*[ik ;ikp;ik ; ikp]-1);
        ind2=cat(1,ind2,2*[ik ;ik ;ikp; ikp]-1);
        kel=[kel;ael*[1;-1;-1;1]];
        ind1=cat(1,ind1,2*[ik ;ikp;ik ; ikp]);
        ind2=cat(1,ind2,2*[ik ;ik ;ikp; ikp]);
        kel=[kel;ael*[1;-1;-1;1]];
        ael=abs(dZm(ij))^2;
        ind1=cat(1,ind1,2*[ik ;ikm;ik ; ikm]-1);
        ind2=cat(1,ind2,2*[ik ;ik ;ikm; ikm]-1);
        kel=[kel;ael*[1;-1;-1;1]];
        ind1=cat(1,ind1,2*[ik ;ikm;ik ; ikm]);
        ind2=cat(1,ind2,2*[ik ;ik ;ikm; ikm]);
        kel=[kel;ael*[1;-1;-1;1]];
        taupotaum=[-imag(dZp(ij));real(dZp(ij))]*[-imag(dZm(ij)),real(dZm(ij))];
        taumotaup=taupotaum';
        ind1=cat(1,ind1,2*[ikm;ikm;ik;ik]-1);
        ind2=cat(1,ind2,2*[ik ;ikp;ik;ikp]-1);
        kel=[kel;taumotaup(1,1)*[1;-1;-1;1]];
        ind1=cat(1,ind1,2*[ikm;ikm;ik;ik ]-1);
        ind2=cat(1,ind2,2*[ik ;ikp;ik;ikp]);
        kel=[kel;taumotaup(1,2)*[1;-1;-1;1]];
        ind1=cat(1,ind1,2*[ikm;ikm;ik;ik ]);
        ind2=cat(1,ind2,2*[ik ;ikp;ik;ikp]-1);
        kel=[kel;taumotaup(2,1)*[1;-1;-1;1]];
        ind1=cat(1,ind1,2*[ikm;ikm;ik;ik ]);
        ind2=cat(1,ind2,2*[ik ;ikp;ik;ikp]);
        kel=[kel;taumotaup(2,2)*[1;-1;-1;1]];
        ind1=cat(1,ind1,2*[ik;ik;ikp;ikp]-1);
        ind2=cat(1,ind2,2*[ikm;ik;ikm;ik]-1);
        kel=[kel;taupotaum(1,1)*[1;-1;-1;1]];
        ind1=cat(1,ind1,2*[ik;ik;ikp;ikp]-1);
        ind2=cat(1,ind2,2*[ikm;ik;ikm;ik]);
        kel=[kel;taupotaum(1,2)*[1;-1;-1;1]];
        ind1=cat(1,ind1,2*[ik;ik;ikp;ikp]);
        ind2=cat(1,ind2,2*[ikm;ik;ikm;ik]-1);
        kel=[kel;taupotaum(2,1)*[1;-1;-1;1]];
        ind1=cat(1,ind1,2*[ik;ik;ikp;ikp]);
        ind2=cat(1,ind2,2*[ikm;ik;ikm;ik]);
        kel=[kel;taupotaum(2,2)*[1;-1;-1;1]];
    end
end

for ibou=1:length(indCrack)
    jbou=indCrack(ibou);
    m=Mesh.NNodeEdge(jbou);
    inode=[Mesh.INodeEdge(jbou):Mesh.INodeEdge(jbou)+m-1];
    Z=Mesh.Znode(inode);

    dZp=Z(2:m)-Z(1:m-1);
    dZp=dZp./(abs(dZp).^2); 
    dZm(2:m)=dZp(1:m-1);

    for ij=2:m-1
        ik=inode(ij);
        ikp=inode(ij+1);
        ikm=inode(ij-1);
        ael=abs(dZp(ij))^2;
        ind1=cat(1,ind1,2*[ik ;ikp;ik ; ikp]-1);
        ind2=cat(1,ind2,2*[ik ;ik ;ikp; ikp]-1);
        kel=[kel;ael*[1;-1;-1;1]];
        ind1=cat(1,ind1,2*[ik ;ikp;ik ; ikp]);
        ind2=cat(1,ind2,2*[ik ;ik ;ikp; ikp]);
        kel=[kel;ael*[1;-1;-1;1]];
        ael=abs(dZm(ij))^2;
        ind1=cat(1,ind1,2*[ik ;ikm;ik ; ikm]-1);
        ind2=cat(1,ind2,2*[ik ;ik ;ikm; ikm]-1);
        kel=[kel;ael*[1;-1;-1;1]];
        ind1=cat(1,ind1,2*[ik ;ikm;ik ; ikm]);
        ind2=cat(1,ind2,2*[ik ;ik ;ikm; ikm]);
        kel=[kel;ael*[1;-1;-1;1]];
        taupotaum=[-imag(dZp(ij));real(dZp(ij))]*[-imag(dZm(ij)),real(dZm(ij))];
        taumotaup=taupotaum';
        ind1=cat(1,ind1,2*[ikm;ikm;ik;ik]-1);
        ind2=cat(1,ind2,2*[ik ;ikp;ik;ikp]-1);
        kel=[kel;taumotaup(1,1)*[1;-1;-1;1]];
        ind1=cat(1,ind1,2*[ikm;ikm;ik;ik ]-1);
        ind2=cat(1,ind2,2*[ik ;ikp;ik;ikp]);
        kel=[kel;taumotaup(1,2)*[1;-1;-1;1]];
        ind1=cat(1,ind1,2*[ikm;ikm;ik;ik ]);
        ind2=cat(1,ind2,2*[ik ;ikp;ik;ikp]-1);
        kel=[kel;taumotaup(2,1)*[1;-1;-1;1]];
        ind1=cat(1,ind1,2*[ikm;ikm;ik;ik ]);
        ind2=cat(1,ind2,2*[ik ;ikp;ik;ikp]);
        kel=[kel;taumotaup(2,2)*[1;-1;-1;1]];
        ind1=cat(1,ind1,2*[ik;ik;ikp;ikp]-1);
        ind2=cat(1,ind2,2*[ikm;ik;ikm;ik]-1);
        kel=[kel;taupotaum(1,1)*[1;-1;-1;1]];
        ind1=cat(1,ind1,2*[ik;ik;ikp;ikp]-1);
        ind2=cat(1,ind2,2*[ikm;ik;ikm;ik]);
        kel=[kel;taupotaum(1,2)*[1;-1;-1;1]];
        ind1=cat(1,ind1,2*[ik;ik;ikp;ikp]);
        ind2=cat(1,ind2,2*[ikm;ik;ikm;ik]-1);
        kel=[kel;taupotaum(2,1)*[1;-1;-1;1]];
        ind1=cat(1,ind1,2*[ik;ik;ikp;ikp]);
        ind2=cat(1,ind2,2*[ikm;ik;ikm;ik]);
        kel=[kel;taupotaum(2,2)*[1;-1;-1;1]];
    end
end




m=2*Mesh.NNodeTot;
K=sparse(ind1,ind2,kel,m,m);
Kedge=real(K'*K);

RefMesh=Mesh.RefMesh;
save(WorkFile.Edge,'Kedge','RefMesh')







