function  TriDICElast(nu,D)

load('./TMP/ImRef.mat','im1'); 
load('./TMP/Mesh.mat','TRI','Znode','NNodeIn','NNodeEdge');
load('./TMP/ImMesh','T','W1','W2','W3');

E=1;
%nu=0.2;
mu=E/2/(1+nu);
lambda=(E/(1-2*nu)-2*mu)/3;
kappa=2*mu/3+lambda;

[nx,ny]=size(im1);
Nelem=size(TRI,1);
NdofIn=2*NNodeIn;
NdofEdge=2*NNodeEdge;
NdofTot=NdofIn+NdofEdge;

j1=[];
j2=[];
kel=[];
hwait=waitbar(0,'Elastic rigidity matrix computation');
for ii=1:Nelem
    waitbar(ii/Nelem,hwait);
    ia=TRI(ii,1);
    ib=TRI(ii,2);
    ic=TRI(ii,3);
    inddof=repmat([2*ia-1;2*ia;2*ib-1;2*ib;2*ic-1;2*ic],[1 6]);
    j1=cat(1,j1,inddof(:));
    inddof=inddof';
    j2=cat(1,j2,inddof(:));
    Z=[Znode(ia),Znode(ib),Znode(ic)];
    [K,M,P]=StiffElem(Z,mu,lambda);
    K=K*(1-D(ii));
    kel=cat(1,kel,K(:));
end
clear K;
K=sparse(j1,j2,kel);
close(hwait);

K=K(:,1:NdofIn)*K(1:NdofIn,:); % Equilibrium gap !

save('./TMP/Elast','K')

