function  TriDICElast2(WorkFile,NewJob,nu,D)

load(WorkFile.ImRef,'im1'); 
load(WorkFile.LastJob,'Job');
load(NewJob.Mesh,'Mesh');
load(WorkFile.ImMesh,'T','W1','W2','W3');

E=1;
mu=E/2/(1+nu);
lambda=(E/(1-2*nu)-2*mu)/3;
kappa=2*mu/3+lambda;

[nx,ny]=size(im1);
Nelem=Mesh.Nelem;
NdofIn=2*Mesh.NNodeIn;
NdofEdge=2*sum(Mesh.NNodeEdge);
NdofTot=NdofIn+NdofEdge;

%hwait=waitbar(0,'Elastic rigidity matrix computation');
j1=zeros(36*Nelem,1);
j2=zeros(36*Nelem,1);
kel=zeros(36*Nelem,1);
for ii=1:Nelem
    %waitbar(ii/Nelem,hwait);
    ia=Mesh.TRI(ii,1);
    ib=Mesh.TRI(ii,2);
    ic=Mesh.TRI(ii,3);
    inddof=repmat([2*ia-1;2*ia;2*ib-1;2*ib;2*ic-1;2*ic],[1 6]);
    j1(36*(ii-1)+[1:36])=inddof(:);
    inddof=inddof';
    j2(36*(ii-1)+[1:36])=inddof(:);
    Z=[Mesh.Znode(ia),Mesh.Znode(ib),Mesh.Znode(ic)];
    [K,M,P,Area]=StiffElem(Z,mu,lambda);
    K=K*(1-D(ii));
    kel(36*(ii-1)+[1:36])=K(:);
end
clear K;
K=sparse(j1,j2,kel);
%close(hwait);

K=K(:,1:NdofIn)*K(1:NdofIn,:); % Equilibrium gap !

RefMesh=Mesh.RefMesh;
save(WorkFile.Elast,'K','RefMesh')

