function     TriDICRigid

load('./TMP/ImRef.mat','im1'); 
load('./TMP/Mesh.mat','TRI','Znode');
load('./TMP/ImMesh','T','W1','W2','W3');
[Gy,Gx]=gradient(im1);
[nx,ny]=size(im1);
Nelem=size(TRI,1);

Gx1=Gx.*W1;
Gx2=Gx.*W2;
Gx3=Gx.*W3;
clear Gx
Gy1=Gy.*W1;
Gy2=Gy.*W2;
Gy3=Gy.*W3;
clear Gy

ind1=[];
ind2=[];
kel=[];
hwait=waitbar(0,'Rigidity matrix computation');
for ii=1:Nelem
    waitbar(ii/Nelem,hwait);
    iinode=TRI(ii,:);
    xmin=floor(min(real(Znode(iinode))));
    xmax=floor(max(real(Znode(iinode))));
    ymin=ceil(min(imag(Znode(iinode))));
    ymax=ceil(max(imag(Znode(iinode))));
    x=[xmin:xmax];
    y=[ymin:ymax];
    [Y,X]=meshgrid(y,x);
    IN=inpolygon(Y,X,imag(Znode(iinode)),real(Znode(iinode)));
    ind=find(IN);
    ix=X(ind);
    iy=Y(ind);
    indim=ix+(iy-1)*nx;
    idof=[2*iinode(1)-1,2*iinode(1),2*iinode(2)-1,2*iinode(2),2*iinode(3)-1,2*iinode(3)];
    f(:,1)=Gx1(indim);
    f(:,2)=Gy1(indim);
    f(:,3)=Gx2(indim);
    f(:,4)=Gy2(indim);
    f(:,5)=Gx3(indim);
    f(:,6)=Gy3(indim);
    for ij=1:6
        ind1=[ind1;idof(ij)];
        ind2=[ind2;idof(ij)];
        kel=[kel;sum(f(:,ij).^2)];
        for ik=ij+1:6
            ind1=[ind1;idof(ij);idof(ik)];
            ind2=[ind2;idof(ik);idof(ij)];
            kel=[kel;sum(f(:,ij).*f(:,ik))*ones(2,1)];
        end
    end
    clear f;
end      
M=sparse(ind1,ind2,kel);
close(hwait);

save('./TMP/Rigid','M')
save('./TMP/Psi','Gx1','Gy1','Gx2','Gy2','Gx3','Gy3')

