function     TriDICRigid2(WorkFile,NewJob)

load(WorkFile.ImRef,'im1'); 
load(NewJob.Mesh,'Mesh');
load(WorkFile.ImMesh,'T','W1','W2','W3');
if NewJob.UseMask
    load(WorkFile.ImMask,'Mask');
    RefMask=NewJob.RefMask;
else
    Mask=logical(ones(size(im1)));
    RefMask=zeros(1,6);
end
[Gy,Gx]=gradient(im1);
[nx,ny]=size(im1);
Nelem=Mesh.Nelem;

Gx(~Mask)=0;
Gy(~Mask)=0;
Gx1=Gx.*W1;
Gx2=Gx.*W2;
Gx3=Gx.*W3;
clear Gx
Gy1=Gy.*W1;
Gy2=Gy.*W2;
Gy3=Gy.*W3;
clear Gy

ind1=zeros(36*Nelem,1);
ind2=zeros(36*Nelem,1);
kel=zeros(36*Nelem,1);
%hwait=waitbar(0,'Rigidity matrix computation');
ijj=0;
for ii=1:Nelem
    %waitbar(ii/Nelem,hwait);
    iinode=Mesh.TRI(ii,:);
    xmin=floor(min(real(Mesh.Znode(iinode))));
    xmax=floor(max(real(Mesh.Znode(iinode))));
    ymin=ceil(min(imag(Mesh.Znode(iinode))));
    ymax=ceil(max(imag(Mesh.Znode(iinode))));
    x=[xmin:xmax];
    y=[ymin:ymax];
    [Y,X]=meshgrid(y,x);
    IN=inpolygon(Y,X,imag(Mesh.Znode(iinode)),real(Mesh.Znode(iinode)));
    ind=find(IN);
    ix=X(ind);
    iy=Y(ind);
    indim=ix+(iy-1)*nx;
    idof=[2*iinode(1)-1,2*iinode(1),2*iinode(2)-1,2*iinode(2),2*iinode(3)-1,2*iinode(3)];
    f(:,1)=Gx1(indim);
    f(:,2)=Gy1(indim);
    f(:,3)=Gx2(indim);
    f(:,4)=Gy2(indim);
    f(:,5)=Gx3(indim);
    f(:,6)=Gy3(indim);
    for ij=1:6
        ind1(ijj+1)=idof(ij);
        ind2(ijj+1)=idof(ij);
        kel(ijj+1)=sum(f(:,ij).^2);
        ijj=ijj+1;
        for ik=ij+1:6
            ind1(ijj+[1:2])=[idof(ij);idof(ik)];
            ind2(ijj+[1:2])=[idof(ik);idof(ij)];
            kel(ijj+[1:2])=sum(f(:,ij).*f(:,ik))*ones(2,1);
            ijj=ijj+2;
        end
    end
    clear f;
end      
M=sparse(ind1,ind2,kel);
%close(hwait);

RefMesh=Mesh.RefMesh;
load(WorkFile.LastJob,'Job');
FileName=Job.Ref;
save(WorkFile.Rigid,'M','RefMesh','RefMask','FileName')
save(WorkFile.Psi,'Gx1','Gy1','Gx2','Gy2','Gx3','Gy3')

