function     S=TriDICSecond2(WorkFile,NewJob,Resid)

load(NewJob.Mesh,'Mesh');
load(WorkFile.ImMesh,'T','W1','W2','W3');
load(WorkFile.Psi,'Gx1','Gy1','Gx2','Gy2','Gx3','Gy3')
[nx,ny]=size(Resid);
Nelem=Mesh.Nelem;
Ndof=2*(Mesh.NNodeTot);
S=zeros(Ndof,1);

for ii=1:Nelem
    iinode=Mesh.TRI(ii,:);
    xmin=floor(min(real(Mesh.Znode(iinode))));
    xmax=floor(max(real(Mesh.Znode(iinode))));
    ymin=ceil(min(imag(Mesh.Znode(iinode))));
    ymax=ceil(max(imag(Mesh.Znode(iinode))));
    x=[xmin:xmax];
    y=[ymin:ymax];
    [Y,X]=meshgrid(y,x);
    IN=inpolygon(Y,X,imag(Mesh.Znode(iinode)),real(Mesh.Znode(iinode)));
    ind=find(IN);
    ix=X(ind);
    iy=Y(ind);
    indim=ix+(iy-1)*nx;
    idof=[2*iinode(1)-1,2*iinode(1),2*iinode(2)-1,2*iinode(2),2*iinode(3)-1,2*iinode(3)];
    f(1)=sum(Gx1(indim).*Resid(indim));
    f(2)=sum(Gy1(indim).*Resid(indim));
    f(3)=sum(Gx2(indim).*Resid(indim));
    f(4)=sum(Gy2(indim).*Resid(indim));
    f(5)=sum(Gx3(indim).*Resid(indim));
    f(6)=sum(Gy3(indim).*Resid(indim));
    for ij=1:6
        S(idof(ij))=S(idof(ij))+f(ij);
    end
end      


