function   [epstr epsdv]=ViewStrain(U, FileMesh,FileImMesh, ROI, D,Param,FlagPlot)

load(FileMesh)
TRI=Mesh.TRI;
Znode=Mesh.Znode;
load(FileImMesh,'T')
E=Param.Young;
nu=Param.nu;
mu=E/2/(1+nu);
lambda=(E/(1-2*nu)-2*mu)/3;
kappa=2*mu/3+lambda;
Nelem=size(TRI,1);


for ii=1:Nelem
    ia=TRI(ii,1);
    ib=TRI(ii,2);
    ic=TRI(ii,3);
    Z=[Znode(ia),Znode(ib),Znode(ic)];
    [Kel,M,P]=StiffElem(Z,mu,lambda);
    Uel=[U(2*ia-1);U(2*ia);U(2*ib-1);U(2*ib);U(2*ic-1);U(2*ic)];
    eps=M*Uel;
    sig=(1-D(ii))*P*Uel;
    epsxx(ii)=eps(1);
    epsyy(ii)=eps(2);
    epsxy(ii)=eps(3)/sqrt(2);
    sigxx(ii)=sig(1);
    sigyy(ii)=sig(2);
    sigxy(ii)=sig(3)/sqrt(2);
end

epstr=epsxx+epsyy;
epsdv=sqrt(.25*(epsxx-epsyy).^2+epsxy.^2);
sigtr=sigxx+sigyy;
sigdv=sqrt(.25*(sigxx-sigyy).^2+sigxy.^2);


if FlagPlot(1)
    im=InterpMeshElem(ROI,T,D);
    Handle=ShowIm(im,'Damage','ROI',ROI,'Colormap','hot');
end

if FlagPlot(2)
    im=InterpMeshElem(ROI,T,epsxx);
    Handle=ShowIm(im,'$\varepsilon_{xx}$','ROI',ROI,'Colormap','hot');
end

if FlagPlot(3)
    im=InterpMeshElem(ROI,T,epsyy);
    Handle=ShowIm(im,'$\varepsilon_{xy}$','ROI',ROI,'Colormap','hot');
end

if FlagPlot(4)
    im=InterpMeshElem(ROI,T,epsxy);
    Handle=ShowIm(im,'$\varepsilon_{yy}$','ROI',ROI,'Colormap','hot');
end

if FlagPlot(5)
    im=InterpMeshElem(ROI,T,epstr);
    Handle=ShowIm(im,'tr$(\varepsilon)$','ROI',ROI,'Colormap','hot');
end

if FlagPlot(6)
    im=InterpMeshElem(ROI,T,epsdv);
    Handle=ShowIm(im,'$\varepsilon_{dev}$','ROI',ROI,'Colormap','hot');
end

if FlagPlot(7)
    im=InterpMeshElem(ROI,T,sigxx);
    Handle=ShowIm(im,'$\sigma_{xx}$','ROI',ROI,'Colormap','hot');
end

if FlagPlot(8)
    im=InterpMeshElem(ROI,T,sigxy);
    Handle=ShowIm(im,'$\sigma_{xy}$','ROI',ROI,'Colormap','hot');
end

if FlagPlot(9)
    im=InterpMeshElem(ROI,T,sigyy);
    Handle=ShowIm(im,'$\sigma_{yy}$','ROI',ROI,'Colormap','hot');
end

if FlagPlot(10)
    im=InterpMeshElem(ROI,T,sigtr);
    Handle=ShowIm(im,'tr$(\sigma)$','ROI',ROI,'Colormap','hot');
end

if FlagPlot(11)
    im=InterpMeshElem(ROI,T,sigdv);
    Handle=ShowIm(im,'$\sigma_{dev}$','ROI',ROI,'Colormap','hot');
end

epstr=InterpMeshElem(ROI,T,epstr);
epsdv=InterpMeshElem(ROI,T,epsdv);
