% program Map1
close all
clear all
set(0,'DefaultAxesFontName','Times','DefaultAxesFontSize',24,'DefaultTextInterpreter','latex');

% Reference: cercle unit reprsent fonctionnellement r-1=0
% Dforme: polygone

m=7;      % number of edges for def polygon
d=0.04;   % distance of edge discretization
dmesh=0.04;% distance between points in the mesh generation
nn=200;   % number of points for the discretization of the reference unit circle
p=10;     % Max polynomial order of transformations z^n
randn('state',sum(100*clock));
a=zeros(2*p,1);
da=zeros(2*p,1);

% Deformee polygone de sommet (complexes) za
t=([0:m]/m-0.5)*pi*2;
za=1.05*exp(i*t);
za=za+(randn(size(za))+i*+randn(size(za)))*.05;
za(end)=za(1);

[zdef0]=SamplePolyBoundary(d,za,0);
nm=length(zdef0);
zdef=zdef0;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

t=([1:nn]/nn-.5)*2*pi;
zref=exp(i*t);
angref=angle(zref);
nor=exp(i*t);
for ii=1:p
    psi(2*ii-1,:)=-real(zref.^(ii).*conj(nor));
    psi(2*ii  ,:)=imag(zref.^(ii).*conj(nor));
end

for ii=1:2*p
    M(ii,ii)=psi(ii,:)*psi(ii,:)';
    for ij=ii+1:2*p
        M(ii,ij)=psi(ii,:)*psi(ij,:)';
        M(ij,ii)=M(ii,ij);
    end
end
M(2,2)=1;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

    figure
    line([real(zdef(:));real(zdef(1))],[imag(zdef(:));imag(zdef(1))],'Color','k','LineWidth',2)
    hold on
    line([real(zref(:));real(zref(1))],[imag(zref(:));imag(zref(1))],'Color','r','LineWidth',2)
    axis image
    xlim([-1 1]*1.2)
    ylim([-1 1]*1.2)
    xlabel('$x$')
    ylabel('$y$')
    set(gca,'Position',[.15 .15 .75 .75])

for iter=1:10
    diff=(abs(zdef(1:end-1))-1);
    ang=angle(zdef(1:end-1));
    diff1=interp1([ang(:)-2*pi;ang(:);ang(:)+2*pi],[diff(:);diff(:);diff(:)],angref);
    S=psi*diff1(:);
    da=M\S;
    da(2)=0;
    a=a+da;
    U=zeros(1,nm);
    for ii=1:p
        U=U+(zdef0.^(ii))*a(2*ii-1);
        U=U+i*(zdef0.^(ii))*a(2*ii);
    end
    zdef=zdef0+U;
end

    figure
    line([real(zdef0(:));real(zdef0(1))],[imag(zdef0(:));imag(zdef0(1))],'Color','k','LineStyle',':')
    hold all
    line([real(zref(:));real(zref(1))],[imag(zref(:));imag(zref(1))],'Color','r','LineWidth',2)
    line([real(zdef(:));real(zdef(1))],[imag(zdef(:));imag(zdef(1))],'Color','k','LineWidth',2)
    axis image
    xlim([-1 1]*1.2)
    ylim([-1 1]*1.2)
    xlabel('$x$')
    ylabel('$y$')
    set(gca,'Position',[.15 .15 .75 .75])



%****************** MESH

[TRI,Z,Nptin,Nptedge]=SimpleMesh(dmesh,za,0);
Zp=Z;
for ii=1:p
    Zp=Zp+(Z.^(ii))*a(2*ii-1);
    Zp=Zp+i*(Z.^(ii))*a(2*ii);
end

    figure('Position',[247   593   672   504])
    line([real(zdef0(:));real(zdef0(1))],[imag(zdef0(:));imag(zdef0(1))],'Color','k')
    hold on
    triplot(TRI,real(Z),imag(Z),'k')
    axis image
    xlim([-1 1]*1.2)
    ylim([-1 1]*1.2)
    xlabel('$x$')
    ylabel('$y$')
    set(gca,'Position',[.15 .15 .75 .75])

    figure('Position',[896   593   672   504])
    line([real(zref(:));real(zref(1))],[imag(zref(:));imag(zref(1))],'Color','r')
    hold on
    triplot(TRI,real(Zp),imag(Zp),'k')
    axis image
    xlim([-1 1]*1.2)
    ylim([-1 1]*1.2)
    xlabel('$x$')
    ylabel('$y$')
    set(gca,'Position',[.15 .15 .75 .75])